'use strict';

var encoding = require('@cosmjs/encoding');
var zustand = require('zustand');
var middleware = require('zustand/middleware');
var Bt = require('long');
var signClient = require('@walletconnect/sign-client');
var utils = require('@walletconnect/utils');
var reactQuery = require('@tanstack/react-query');
var react = require('react');
var cosmwasmStargate = require('@cosmjs/cosmwasm-stargate');
var stargate = require('@cosmjs/stargate');
var tendermintRpc = require('@cosmjs/tendermint-rpc');
var shallow = require('zustand/shallow');
var jsxRuntime = require('react/jsx-runtime');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var Bt__default = /*#__PURE__*/_interopDefault(Bt);

var xt=Object.defineProperty,Wt=Object.defineProperties;var vt=Object.getOwnPropertyDescriptors;var re=Object.getOwnPropertySymbols;var Le=Object.prototype.hasOwnProperty,Ke=Object.prototype.propertyIsEnumerable;var De=(e,t,n)=>t in e?xt(e,t,{enumerable:!0,configurable:!0,writable:!0,value:n}):e[t]=n,E=(e,t)=>{for(var n in t||(t={}))Le.call(t,n)&&De(e,n,t[n]);if(re)for(var n of re(t))Ke.call(t,n)&&De(e,n,t[n]);return e},N=(e,t)=>Wt(e,vt(t));var Ue=(e,t)=>{var n={};for(var i in e)Le.call(e,i)&&t.indexOf(i)<0&&(n[i]=e[i]);if(e!=null&&re)for(var i of re(e))t.indexOf(i)<0&&Ke.call(e,i)&&(n[i]=e[i]);return n};var l=(e,t,n)=>new Promise((i,r)=>{var o=c=>{try{a(n.next(c));}catch(u){r(u);}},s=c=>{try{a(n.throw(c));}catch(u){r(u);}},a=c=>c.done?i(c.value):Promise.resolve(c.value).then(o,s);a((n=n.apply(e,t)).next());});var X="graz-reconnect-session";var qe=(m=>(m.KEPLR="keplr",m.LEAP="leap",m.VECTIS="vectis",m.COSMOSTATION="cosmostation",m.WALLETCONNECT="walletconnect",m.WC_KEPLR_MOBILE="wc_keplr_mobile",m.WC_LEAP_MOBILE="wc_leap_mobile",m.WC_COSMOSTATION_MOBILE="wc_cosmostation_mobile",m.METAMASK_SNAP_LEAP="metamask_snap_leap",m.STATION="station",m))(qe||{}),Ge=["keplr","leap","vectis","cosmostation","walletconnect","wc_keplr_mobile","wc_leap_mobile","wc_cosmostation_mobile","metamask_snap_leap","station"];var kt={recentChainIds:null,chains:null,chainsConfig:null,multiChainFetchConcurrency:3,walletType:"keplr",walletConnect:{options:null,web3Modal:null},_notFoundFn:()=>null,_onReconnectFailed:()=>null,_reconnect:!1,_reconnectConnector:null},Z={accounts:null,activeChainIds:null,status:"disconnected",wcSignClients:new Map},Pt={name:"graz-session",version:2,partialize:e=>({accounts:e.accounts,activeChainIds:e.activeChainIds}),storage:middleware.createJSONStorage(()=>sessionStorage)},Nt={name:"graz-internal",partialize:e=>({recentChainIds:e.recentChainIds,_reconnect:e._reconnect,_reconnectConnector:e._reconnectConnector}),version:2},y=zustand.create(middleware.subscribeWithSelector(middleware.persist(()=>Z,Pt))),d=zustand.create(middleware.subscribeWithSelector(middleware.persist(()=>kt,Nt)));var se=()=>{if(typeof window.cosmostation.providers.keplr!="undefined"){let e=window.cosmostation.providers.keplr;return Object.assign(e,{subscription:i=>{let r=()=>{z(),i();};return window.cosmostation.cosmos.on("accountChanged",r),()=>{window.cosmostation.cosmos.off("accountChanged",r);}}})}throw d.getState()._notFoundFn(),new Error("window.cosmostation.providers.keplr is not defined")};var ae=()=>{if(typeof window.keplr!="undefined"){let e=window.keplr;return Object.assign(e,{subscription:i=>{let r=()=>{z(),i();};return window.addEventListener("keplr_keystorechange",r),()=>{window.removeEventListener("keplr_keystorechange",r);}}})}throw d.getState()._notFoundFn(),new Error("window.keplr is not defined")};var ce=()=>{if(typeof window.leap!="undefined"){let e=window.leap;return Object.assign(e,{subscription:i=>{let r=()=>{z(),i();};return window.addEventListener("leap_keystorechange",r),()=>{window.removeEventListener("leap_keystorechange",r);}}})}throw d.getState()._notFoundFn(),new Error("window.leap is not defined")};var je=e=>{let t=window.ethereum;if(t&&e){let n=()=>l(void 0,null,function*(){return yield t.request({method:"wallet_getSnaps"})}),i=C=>l(void 0,null,function*(){try{let A=yield n();return Object.values(A).find(M=>M.id===e.id&&(!C||M.version===C))}catch(A){return}}),r=()=>l(void 0,null,function*(){yield t.request({method:"wallet_requestSnaps",params:{[e.id]:e.params||{}}});}),o=()=>l(void 0,null,function*(){var B;let C=yield t.request({method:"web3_clientVersion"});if(!C.includes("MetaMask"))throw new Error("Metamask is not installed");let M=(B=C.split("MetaMask/v")[1])==null?void 0:B.split(".")[0];if(!(Number(M)>=11))throw new Error("Metamask Snap is not supported in this version");return (yield i())||(yield r()),!0}),s=C=>l(void 0,null,function*(){(yield i())||(yield r());}),a=(C,A,M)=>l(void 0,null,function*(){let P=yield t.request({method:"wallet_invokeSnap",params:{snapId:e.id,request:{method:"signDirect",params:{chainId:C,signerAddress:A,signDoc:M}}}}),D=M.accountNumber,B=new Bt__default.default(D.low,D.high,D.unsigned);return {signature:P.signature,signed:N(E({},P.signed),{accountNumber:`${B.toString()}`,authInfoBytes:new Uint8Array(Object.values(P.signed.authInfoBytes)),bodyBytes:new Uint8Array(Object.values(P.signed.bodyBytes))})}}),c=(C,A,M)=>l(void 0,null,function*(){return yield t.request({method:"wallet_invokeSnap",params:{snapId:e.id,request:{method:"signAmino",params:{chainId:C,signerAddress:A,signDoc:M}}}})}),u=C=>l(void 0,null,function*(){let A=yield t.request({method:"wallet_invokeSnap",params:{snapId:e.id,request:{method:"getKey",params:{chainId:C}}}});if(!A)throw new Error("No response from Metamask");return A.pubKey=Uint8Array.from(Object.values(A.pubkey)),delete A.pubkey,E({},A)}),m=C=>l(void 0,null,function*(){let A=yield u(C);return {address:A.bech32Address,algo:A.algo,pubkey:A.pubKey}}),S=(...C)=>l(void 0,null,function*(){let[A,M,P,D]=C;return yield c(A,M,P)}),w=(...C)=>l(void 0,null,function*(){let[A,M,P]=C;return yield a(A,M,P)}),h=C=>({getAccounts:()=>l(void 0,null,function*(){return [yield m(C)]}),signDirect:(A,M)=>w(C,A,M)}),b=C=>({getAccounts:()=>l(void 0,null,function*(){return [yield m(C)]}),signAmino:(A,M)=>S(C,A,M)});return {enable:s,experimentalSuggestChain:(...C)=>l(void 0,null,function*(){yield o(),yield t.request({method:"wallet_invokeSnap",params:{snapId:e.id,request:{method:"suggestChain",params:{chainInfo:C[0]}}}});}),getKey:u,getOfflineSigner:C=>({getAccounts:()=>l(void 0,null,function*(){return [yield m(C)]}),signDirect:(A,M)=>w(C,A,M),signAmino:(A,M)=>S(C,A,M)}),getOfflineSignerAuto:C=>l(void 0,null,function*(){return (yield u(C)).isNanoLedger?b(C):h(C)}),getOfflineSignerOnlyAmino:b,init:o,signAmino:S,signDirect:w}}throw d.getState()._notFoundFn(),new Error("window.ethereum is not defined")};var $e=()=>je({id:"npm:@leapwallet/metamask-cosmos-snap"});var le=()=>{if(typeof window.station!="undefined"){let e=window.station.keplr;return {subscription:o=>{let s=()=>{z(),o();};return window.addEventListener("station_wallet_change",s),()=>{window.removeEventListener("station_wallet_change",s);}},getKey:o=>l(void 0,null,function*(){let s=yield e.getKey(o);return E({isKeystone:!1},s)}),getOfflineSigner:o=>{try{let s=e.getOfflineSignerOnlyAmino(o);return Object.assign(s,{signDirect:(u,m)=>{throw new Error("signDirect not supported by Station")}})}catch(s){throw console.error(s),s}},experimentalSuggestChain:o=>l(void 0,null,function*(){try{let s=Object.assign(o,{chainSymbolImageUrl:o.chainSymbolImageUrl||"",stakeCurrency:{coinDecimals:o.stakeCurrency.coinDecimals,coinDenom:o.stakeCurrency.coinDenom,coinImageUrl:o.stakeCurrency.coinImageUrl||"",coinMinimalDenom:o.stakeCurrency.coinMinimalDenom},currencies:o.currencies.map(a=>({coinDecimals:a.coinDecimals,coinDenom:a.coinDenom,coinImageUrl:a.coinImageUrl||"",coinMinimalDenom:a.coinMinimalDenom})),feeCurrencies:o.feeCurrencies.map(a=>{var c,u,m;return {coinDecimals:a.coinDecimals,coinDenom:a.coinDenom,coinImageUrl:a.coinImageUrl||"",coinMinimalDenom:a.coinMinimalDenom,gasPriceStep:{average:((c=a.gasPriceStep)==null?void 0:c.average)||0,high:((u=a.gasPriceStep)==null?void 0:u.high)||0,low:((m=a.gasPriceStep)==null?void 0:m.low)||0}}})});yield e.experimentalSuggestChain(s);}catch(s){throw console.error(s),s}}),enable:o=>e.enable(o),disable:o=>e.disable(o),getOfflineSignerAuto:o=>e.getOfflineSignerAuto(o),getOfflineSignerOnlyAmino:o=>e.getOfflineSignerOnlyAmino(o),signDirect:()=>e.signDirect(),signAmino:(o,s,a,c)=>e.signAmino(o,s,a)}}throw d.getState()._notFoundFn(),new Error("window.station is not defined")};var ue=()=>{if(typeof window.vectis!="undefined"){let e=window.vectis.cosmos;return {enable:a=>e.enable(a),getOfflineSigner:a=>e.getOfflineSigner(a),getOfflineSignerAuto:a=>e.getOfflineSignerAuto(a),getKey:a=>l(void 0,null,function*(){let c=yield e.getKey(a);return {address:encoding.fromBech32(c.address).data,algo:c.algo,bech32Address:c.address,name:c.name,pubKey:c.pubKey,isKeystone:!1,isNanoLedger:c.isNanoLedger}}),subscription:a=>{let c=()=>{z(),a();};return window.addEventListener("vectis_accountChanged",c),()=>{window.removeEventListener("vectis_accountChanged",c);}},getOfflineSignerOnlyAmino:(...a)=>e.getOfflineSignerAmino(...a),experimentalSuggestChain:(...a)=>l(void 0,null,function*(){let[c]=a,u=N(E({},c),{rpcUrl:c.rpc,restUrl:c.rest,prettyName:c.chainName.replace(" ",""),bech32Prefix:c.bech32Config.bech32PrefixAccAddr});return e.suggestChains([u])}),signDirect:(...a)=>l(void 0,null,function*(){var m;let{1:c,2:u}=a;return e.signDirect(c,{bodyBytes:u.bodyBytes||Uint8Array.from([]),authInfoBytes:u.authInfoBytes||Uint8Array.from([]),accountNumber:Bt__default.default.fromString(((m=u.accountNumber)==null?void 0:m.toString())||"",!1),chainId:u.chainId||""})}),signAmino:(...a)=>l(void 0,null,function*(){let{1:c,2:u}=a;return e.signAmino(c,u)})}}throw d.getState()._notFoundFn(),new Error("window.vectis is not defined")};var Q=()=>typeof window!="undefined"?!!(window.matchMedia("(pointer:coarse)").matches||/Android|webOS|iPhone|iPad|iPod|BlackBerry|Opera Mini/u.test(navigator.userAgent)):!1,He=()=>Q()&&navigator.userAgent.toLowerCase().includes("android"),Ve=()=>Q()&&(navigator.userAgent.toLowerCase().includes("iphone")||navigator.userAgent.toLowerCase().includes("ipad"));var Ae=(e,t,n=new Error("Promise timed out"))=>{let i=new Promise((r,o)=>{setTimeout(()=>{o(n);},t);});return Promise.race([e,i])};var j=e=>{var B,te,ke;if(!((ke=(te=(B=d.getState().walletConnect)==null?void 0:B.options)==null?void 0:te.projectId)!=null&&ke.trim()))throw new Error("walletConnect.options.projectId is not defined");let t=(e==null?void 0:e.walletType)||"walletconnect",n=(e==null?void 0:e.encoding)||"base64",i=p=>{if(!e)return;let{appUrl:f,formatNativeUrl:g}=e;if(Q()){if(He())if(!p)window.open(f.mobile.android,"_self","noreferrer noopener");else {let I=g(f.mobile.android,p,"android");window.open(I,"_self","noreferrer noopener");}if(Ve())if(!p)window.open(f.mobile.ios,"_self","noreferrer noopener");else {let I=g(f.mobile.ios,p,"ios");window.open(I,"_self","noreferrer noopener");}}},r=()=>{let{wcSignClients:p}=y.getState();if(!p.get(t))throw new Error("walletConnect.signClient is not defined");p.delete(t),y.setState({wcSignClients:p}),d.setState({_reconnect:!1,_reconnectConnector:null,recentChainIds:null});},o=p=>l(void 0,null,function*(){let{wcSignClients:f}=y.getState(),g=f.get(t);if(!g)throw new Error("walletConnect.signClient is not defined");if(!p)throw new Error("No wallet connect session");yield g.disconnect({topic:p,reason:utils.getSdkError("USER_DISCONNECTED")}),yield c(g);}),s=p=>{try{let{wcSignClients:f}=y.getState(),g=f.get(t);if(!g)throw new Error("walletConnect.signClient is not defined");let I=g.session.getAll().at(-1);if(!I)return;if(!(I.expiry*1e3>Date.now()+1e3))throw o(I.topic),new Error("invalid session");try{let x=g.find({requiredNamespaces:{cosmos:{methods:["cosmos_getAccounts","cosmos_signAmino","cosmos_signDirect"],chains:p.map(U=>`cosmos:${U}`),events:["chainChanged","accountsChanged"]}}});if(!x.length)throw new Error("no session");return x.at(-1)}catch(x){if(!x.message.toLowerCase().includes("no matching key"))throw x}return I}catch(f){if(!f.message.toLowerCase().includes("no matching key"))throw f}},a=p=>{try{return s(p)}catch(f){return}},c=p=>l(void 0,null,function*(){try{let f=p.core.pairing.pairings.getAll({active:!1});if(!f.length)return;yield Promise.all(f.map(g=>l(void 0,null,function*(){yield p.core.pairing.pairings.delete(g.topic,{code:7001,message:"clear pairing"});})));}catch(f){if(!f.message.toLowerCase().includes("no matching key"))throw f}}),u=()=>l(void 0,null,function*(){let{walletConnect:p}=d.getState();if(!(p!=null&&p.options))throw new Error("walletConnect.options is not defined");let{wcSignClients:f}=y.getState(),g=f.get(t);if(g)return g;let I=yield signClient.SignClient.init(p.options);return f.set(t,I),y.setState({wcSignClients:f}),I}),m=p=>{let{wcSignClients:f}=y.getState(),g=f.get(t);if(!g)return ()=>{};let I=v=>{let x=y.getState().accounts;if(v.params.event.name==="accountsChanged"&&x&&!Object.values(x).map(U=>U.bech32Address).includes(v.params.event.data[0])){let U=v.params.chainId.split(":")[1];U&&S([U]);}else p();};return g.events.on("session_delete",r),g.events.on("session_expire",r),g.events.on("session_event",I),()=>{g.events.off("session_delete",r),g.events.off("session_expire",r),g.events.off("session_event",I);}},S=p=>l(void 0,null,function*(){var ne;let f=typeof p=="string"?[p]:p,{wcSignClients:g}=y.getState(),I=g.get(t);if(!I)throw new Error("enable walletConnect.signClient is not defined");let{walletConnect:v,chains:x}=d.getState();if(!((ne=v==null?void 0:v.options)!=null&&ne.projectId))throw new Error("walletConnect.options.projectId is not defined");let{Web3Modal:U}=yield import('@web3modal/standalone'),$=new U(E({projectId:v.options.projectId,walletConnectVersion:2,enableExplorer:!1,explorerRecommendedWalletIds:"NONE"},v.web3Modal)),V=a(f);if(!V){let{uri:L,approval:Y}=yield Ae(I.connect({requiredNamespaces:{cosmos:{methods:["cosmos_getAccounts","cosmos_signAmino","cosmos_signDirect"],chains:f.map(G=>`cosmos:${G}`),events:["chainChanged","accountsChanged"]}}}),15e3,new Error("Connection timeout"));if(!L)throw new Error("No wallet connect uri");e?i(L):yield $.openModal({uri:L});let oe=G=>l(void 0,null,function*(){return G.aborted?Promise.reject(new Error("User closed wallet connect")):new Promise((Se,J)=>{Y().then(Pe=>{let Ne=Pe.sessionProperties;if(!Ne)return J(new Error("No session properties"));let we=JSON.parse(String(Ne.keys));if(we.length===0)return J(new Error("No accounts"));let Be=we[0];if(!Be)return J(new Error("No accounts"));let _e={};return f.forEach(ie=>{_e[ie]=N(E({},Be),{bech32Address:encoding.toBech32(x.find(Mt=>Mt.chainId===ie).bech32Config.bech32PrefixAccAddr,encoding.fromBech32(we[0].bech32Address).data)});}),y.setState(ie=>({accounts:E(E({},ie.accounts||{}),_e)})),Se(Pe)}).catch(J),G.addEventListener("abort",()=>{J(new Error("User closed wallet connect"));},{once:!0});})});try{let G=new AbortController,Se=G.signal;$.subscribeModal(J=>{J.open||G.abort();}),yield oe(Se);}catch(G){if($.closeModal(),!G.message.toLowerCase().includes("no matching key"))return Promise.reject(G)}return e||$.closeModal(),Promise.resolve()}try{yield Ae((()=>l(void 0,null,function*(){let L=yield h(f[0]),Y={};f.forEach(oe=>{Y[oe]=N(E({},L),{bech32Address:encoding.toBech32(x.find(G=>G.chainId===oe).bech32Config.bech32PrefixAccAddr,encoding.fromBech32(L.bech32Address).data)});}),y.setState({accounts:Y});}))(),15e3,new Error("Connection timeout"));}catch(L){if(o(V.topic),!L.message.toLowerCase().includes("no matching key"))throw L}}),w=p=>l(void 0,null,function*(){var x;let{wcSignClients:f}=y.getState(),g=f.get(t);if(!g)throw new Error("walletConnect.signClient is not defined");let I=(x=s([p]))==null?void 0:x.topic;if(!I)throw new Error("No wallet connect session");let v=yield g.request({topic:I,chainId:`cosmos:${p}`,request:{method:"cosmos_getAccounts",params:{}}});if(!v[0])throw new Error("No wallet connect account");return {address:v[0].address,algo:v[0].algo,pubkey:new Uint8Array(Buffer.from(v[0].pubkey,n))}}),h=p=>l(void 0,null,function*(){let{address:f,algo:g,pubkey:I}=yield w(p);return {address:encoding.fromBech32(f).data,algo:g,bech32Address:f,name:"",pubKey:I,isKeystone:!1,isNanoLedger:!1}}),b=(...p)=>l(void 0,null,function*(){var L,Y;let[f,g,I]=p,{accounts:v,wcSignClients:x}=y.getState(),U=x.get(t);if(!U)throw new Error("walletConnect.signClient is not defined");if(!v)throw new Error("account is not defined");let $=(L=s([f]))==null?void 0:L.topic;if(!$)throw new Error("No wallet connect session");if(!I.bodyBytes)throw new Error("No bodyBytes");if(!I.authInfoBytes)throw new Error("No authInfoBytes");let V={topic:$,chainId:`cosmos:${f}`,request:{method:"cosmos_signDirect",params:{signerAddress:g,signDoc:N(E({},I),{bodyBytes:Buffer.from(I.bodyBytes).toString(n),authInfoBytes:Buffer.from(I.authInfoBytes).toString(n),accountNumber:(Y=I.accountNumber)==null?void 0:Y.toString()})}}};return i(),yield U.request(V)}),T=(...p)=>l(void 0,null,function*(){let[f,g,I]=p,{signature:v,signed:x}=yield b(f,g,I);return {signed:{chainId:x.chainId,accountNumber:Bt__default.default.fromString(x.accountNumber,!1),authInfoBytes:new Uint8Array(Buffer.from(x.authInfoBytes,n)),bodyBytes:new Uint8Array(Buffer.from(x.bodyBytes,n))},signature:v}}),W=(...p)=>l(void 0,null,function*(){var L;let[f,g,I,v]=p,{wcSignClients:x}=y.getState(),U=x.get(t),{accounts:$}=y.getState();if(!U)throw new Error("walletConnect.signClient is not defined");if(!$)throw new Error("account is not defined");let V=(L=s([f]))==null?void 0:L.topic;if(!V)throw new Error("No wallet connect session");return i(),yield U.request({topic:V,chainId:`cosmos:${f}`,request:{method:"cosmos_signDirect",params:{signerAddress:g,signDoc:I}}})}),k=(...p)=>l(void 0,null,function*(){let[f,g,I,v]=p;return yield W(f,g,I)}),C=p=>({getAccounts:()=>l(void 0,null,function*(){return [yield w(p)]}),signDirect:(f,g)=>T(p,f,g)}),A=p=>({getAccounts:()=>l(void 0,null,function*(){return [yield w(p)]}),signAmino:(f,g)=>k(p,f,g)});return {enable:S,disable:p=>l(void 0,null,function*(){var I;let{wcSignClients:f}=y.getState(),g=f.get(t);if(p===void 0){let v=g==null?void 0:g.session.getAll();v!==void 0&&(yield Promise.all(v.map(x=>o(x.topic))));}else typeof p=="string"?yield o((I=s([p]))==null?void 0:I.topic):yield Promise.all(p.map(v=>{var x;return o((x=s([v]))==null?void 0:x.topic)}));(g==null?void 0:g.session.getAll().length)===0&&r();}),experimentalSuggestChain:(...p)=>l(void 0,null,function*(){yield Promise.reject(new Error("WalletConnect does not support experimentalSuggestChain"));}),getKey:h,getOfflineSigner:p=>({getAccounts:()=>l(void 0,null,function*(){return [yield w(p)]}),signDirect:(f,g)=>T(p,f,g),signAmino:(f,g)=>k(p,f,g)}),getOfflineSignerAuto:p=>l(void 0,null,function*(){return (yield h(p)).isNanoLedger?A(p):C(p)}),getOfflineSignerOnlyAmino:A,signAmino:k,signDirect:T,subscription:m,init:u}};var Je=()=>{var t,n,i;if(!((i=(n=(t=d.getState().walletConnect)==null?void 0:t.options)==null?void 0:n.projectId)!=null&&i.trim()))throw new Error("walletConnect.options.projectId is not defined");if(!Q())throw new Error("WalletConnect Cosmostation mobile is only supported in mobile");let e={encoding:"hex",appUrl:{mobile:{ios:"cosmostation://",android:"cosmostation://"}},walletType:"wc_cosmostation_mobile",formatNativeUrl:(r,o,s)=>`${r.replaceAll("/","").replaceAll(":","")}://wc?${o}`};return j(e)};var Xe=()=>{var t,n,i;if(!((i=(n=(t=d.getState().walletConnect)==null?void 0:t.options)==null?void 0:n.projectId)!=null&&i.trim()))throw new Error("walletConnect.options.projectId is not defined");if(!Q())throw new Error("WalletConnect Keplr mobile is only supported in mobile");let e={encoding:"base64",appUrl:{mobile:{ios:"keplrwallet://",android:"intent://"}},walletType:"wc_keplr_mobile",formatNativeUrl:(r,o,s)=>{let a=r.replaceAll("/","").replaceAll(":",""),c=encodeURIComponent(o);switch(s){case"ios":return `${a}://wcV2?${c}`;case"android":return `${a}://wcV2?${c}#Intent;package=com.chainapsis.keplr;scheme=keplrwallet;end;`;default:return `${a}://wc?uri=${c}`}}};return j(e)};var Ze=()=>{var t,n,i;if(!((i=(n=(t=d.getState().walletConnect)==null?void 0:t.options)==null?void 0:n.projectId)!=null&&i.trim()))throw new Error("walletConnect.options.projectId is not defined");if(!Q())throw new Error("WalletConnect Leap mobile is only supported in mobile");let e={encoding:"base64",appUrl:{mobile:{ios:"leapcosmos://",android:"intent://"}},walletType:"wc_leap_mobile",formatNativeUrl:(r,o,s)=>{let a=r.replaceAll("/","").replaceAll(":",""),c=encodeURIComponent(o);switch(s){case"ios":return `${a}://wcV2?${c}`;case"android":return `${a}://wcV2?${c}#Intent;package=io.leapwallet.cosmos;scheme=leapwallet;end;`;default:return `${a}://wc?uri=${c}`}}};return j(e)};var _=(e=d.getState().walletType)=>{try{return R(e),!0}catch(t){return !1}},z=()=>{window.sessionStorage.removeItem(X),y.setState(Z);},R=(e=d.getState().walletType)=>{switch(e){case"keplr":return ae();case"leap":return ce();case"cosmostation":return se();case"vectis":return ue();case"walletconnect":return j();case"wc_keplr_mobile":return Xe();case"wc_leap_mobile":return Ze();case"wc_cosmostation_mobile":return Je();case"metamask_snap_leap":return $e();case"station":return le();default:throw new Error("Unknown wallet type")}},Ko=()=>Object.fromEntries(Ge.map(e=>[e,_(e)])),et=e=>e==="walletconnect"||e==="wc_keplr_mobile"||e==="wc_leap_mobile"||e==="wc_cosmostation_mobile";var ee=e=>l(void 0,null,function*(){var t;try{let{recentChainIds:n,chains:i,walletType:r}=d.getState(),o=(e==null?void 0:e.walletType)||r;if(!_(o))throw new Error(`${o} is not available`);let a=R(o),c=typeof(e==null?void 0:e.chainId)=="string"?[e.chainId]:(e==null?void 0:e.chainId)||n;if(!c)throw new Error("No last known connected chain, connect action requires chain ids");let u=i==null?void 0:i.map(h=>h.chainId);c.forEach(h=>{if(!(u!=null&&u.includes(h)))throw new Error(`Chain ${h} is not provided in GrazProvider`)}),y.setState(h=>{let b=d.getState()._reconnect||!!d.getState()._reconnectConnector||!!c;return h.activeChainIds&&c.filter(W=>{var k;return !((k=h.activeChainIds)!=null&&k.includes(W))}).length>0?{status:"connecting"}:b?{status:"reconnecting"}:{status:"connecting"}});let{accounts:m}=y.getState();if(yield (t=a.init)==null?void 0:t.call(a),yield a.enable(c),!et(o)){let h=yield a.getKey(c[0]),b={};c.forEach(T=>{b[T]=N(E({},h),{bech32Address:encoding.toBech32(i.find(W=>W.chainId===T).bech32Config.bech32PrefixAccAddr,encoding.fromBech32(h.bech32Address).data)});}),y.setState(T=>({accounts:E(E({},T.accounts||{}),b)}));}d.setState(h=>({recentChainIds:[...h.recentChainIds||[],...c].filter((b,T,W)=>W.indexOf(b)===T)})),y.setState(h=>({activeChainIds:[...h.activeChainIds||[],...c].filter((b,T,W)=>W.indexOf(b)===T)})),d.setState({walletType:o,_reconnect:!!(e!=null&&e.autoReconnect),_reconnectConnector:o}),y.setState({status:"connected"}),typeof window!="undefined"&&window.sessionStorage.setItem(X,"Active");let S=c.map(h=>i.find(b=>b.chainId===h));return {accounts:y.getState().accounts,walletType:o,chains:S}}catch(n){throw console.error("connect ",n),y.getState().accounts===null&&y.setState({status:"disconnected"}),y.getState().accounts&&y.getState().activeChainIds&&y.setState({status:"connected"}),n}}),Te=e=>{typeof window!="undefined"&&window.sessionStorage.removeItem(X);let t=typeof(e==null?void 0:e.chainId)=="string"?[e.chainId]:e==null?void 0:e.chainId;if(t){let n=y.getState().accounts;t.forEach(r=>{n==null||delete n[r];}),Object.values(n||{}).length===0?(y.setState(Z),d.setState({_reconnect:!1,_reconnectConnector:null,recentChainIds:null})):(y.setState(r=>{var o;return {activeChainIds:(o=r.activeChainIds)==null?void 0:o.filter(s=>!t.includes(s)),accounts:n}}),d.setState(r=>{var o;return {recentChainIds:(o=r.recentChainIds)==null?void 0:o.filter(s=>!t.includes(s))}}));}else y.setState(Z),d.setState({_reconnect:!1,_reconnectConnector:null,recentChainIds:null});return Promise.resolve()},F=e=>l(void 0,null,function*(){var r;let{recentChainIds:t,_reconnectConnector:n,_reconnect:i}=d.getState();try{let o=_(n||void 0);if(t&&o&&n)return yield ee({chainId:t,walletType:n,autoReconnect:i})}catch(o){(r=e==null?void 0:e.onError)==null||r.call(e,o),Te();}}),tt=e=>l(void 0,null,function*(){if(!(e!=null&&e.chainId))throw new Error("chainId is required");let{walletType:t}=d.getState(),n=e.walletType||t;if(!_(n))throw new Error(`${n} is not available`);let r=R(n),o=r.getOfflineSigner(e.chainId),s=r.getOfflineSignerOnlyAmino(e.chainId),a=yield r.getOfflineSignerAuto(e.chainId);return {offlineSigner:o,offlineSignerAmino:s,offlineSignerAuto:a}});var Ee=()=>{d.setState({recentChainIds:null});},Xo=()=>d.getState().recentChainIds,Zo=()=>{var n;let{recentChainIds:e,chains:t}=d.getState();return (n=e==null?void 0:e.map(i=>t.find(r=>r.chainId===i)))!=null?n:null},be=n=>l(void 0,[n],function*({chainInfo:e,walletType:t}){return yield R(t).experimentalSuggestChain(e),e}),nt=e=>l(void 0,null,function*(){var i;let t=d.getState().walletType;return yield be({chainInfo:e.chainInfo,walletType:(i=e.walletType)!=null?i:t}),yield ee({chainId:e.chainInfo.chainId,walletType:e.walletType,autoReconnect:e.autoReconnect})});var ot=e=>(d.setState(t=>({walletConnect:e.walletConnect||t.walletConnect,walletType:e.defaultWallet||t.walletType,chains:e.chains,chainsConfig:e.chainsConfig||t.chainsConfig,multiChainFetchConcurrency:e.multiChainFetchConcurrency||t.multiChainFetchConcurrency,_notFoundFn:e.onNotFound||t._notFoundFn,_onReconnectFailed:e.onReconnectFailed||t._onReconnectFailed,_reconnect:e.autoReconnect===void 0?!0:e.autoReconnect||t._reconnect})),e);var it=s=>l(void 0,[s],function*({signingClient:e,senderAddress:t,recipientAddress:n,amount:i,fee:r,memo:o}){if(!e)throw new Error("No connected account detected");if(!t)throw new Error("senderAddress is not defined");return e.sendTokens(t,n,i,r,o)}),rt=m=>l(void 0,[m],function*({signingClient:e,senderAddress:t,recipientAddress:n,transferAmount:i,sourcePort:r,sourceChannel:o,timeoutHeight:s,timeoutTimestamp:a,fee:c,memo:u}){if(!e)throw new Error("Stargate signing client is not ready");if(!t)throw new Error("senderAddress is not defined");return e.sendIbcTokens(t,n,i,r,o,s,a,c,u)}),st=a=>l(void 0,[a],function*({signingClient:e,senderAddress:t,msg:n,fee:i,options:r,label:o,codeId:s}){if(!e)throw new Error("CosmWasm signing client is not ready");return e.instantiate(t,s,n,o,i,r)}),at=a=>l(void 0,[a],function*({signingClient:e,senderAddress:t,msg:n,fee:i,contractAddress:r,funds:o,memo:s}){if(!e)throw new Error("CosmWasm signing client is not ready");return e.execute(t,r,n,i,s,o)}),ct=(e,t,n)=>l(void 0,null,function*(){if(!n)throw new Error("CosmWasm client is not ready");return yield n.queryContractSmart(e,t)}),lt=(e,t,n)=>{if(!n)throw new Error("CosmWasm client is not ready");let i=new TextEncoder().encode(t);return n.queryContractRaw(e,i)};var li=e=>e,ui=e=>e;var de=e=>e?Object.keys(e).length===0:!0;var Oe=class extends Error{constructor(t){super(),this.name="AbortError",this.message=t;}},ut=e=>globalThis.DOMException===void 0?new Oe(e):new DOMException(e),dt=e=>{let t=e.reason===void 0?ut("This operation was aborted."):e.reason;return t instanceof Error?t:ut(t)};function Me(o,s){return l(this,arguments,function*(e,t,{concurrency:n=Number.POSITIVE_INFINITY,stopOnError:i=!0,signal:r}={}){return new Promise((a,c)=>{if(e[Symbol.iterator]===void 0&&e[Symbol.asyncIterator]===void 0)throw new TypeError(`Expected \`input\` to be either an \`Iterable\` or \`AsyncIterable\`, got (${typeof e})`);if(typeof t!="function")throw new TypeError("Mapper function is required");if(!((Number.isSafeInteger(n)||n===Number.POSITIVE_INFINITY)&&n>=1))throw new TypeError(`Expected \`concurrency\` to be an integer from 1 and up or \`Infinity\`, got \`${n}\` (${typeof n})`);let u=[],m=[],S=new Map,w=!1,h=!1,b=!1,T=0,W=0,k=e[Symbol.iterator]===void 0?e[Symbol.asyncIterator]():e[Symbol.iterator](),C=M=>{w=!0,h=!0,c(M);};r&&(r.aborted&&C(dt(r)),r.addEventListener("abort",()=>{C(dt(r));}));let A=()=>l(this,null,function*(){if(h)return;let M=yield k.next(),P=W;if(W++,M.done){if(b=!0,T===0&&!h){if(!i&&m.length>0){C(new AggregateError(m));return}if(h=!0,S.size===0){a(u);return}let D=[];for(let[B,te]of u.entries())S.get(B)!==mt&&D.push(te);a(D);}return}T++,l(this,null,function*(){try{let D=yield M.value;if(h)return;let B=yield t(D,P);B===mt&&S.set(P,B),u[P]=B,T--,yield A();}catch(D){if(i)C(D);else {m.push(D),T--;try{yield A();}catch(B){C(B);}}}});});l(this,null,function*(){for(let M=0;M<n;M++){try{yield A();}catch(P){C(P);break}if(b||w)break}});})})}var mt=Symbol("skip");var K=({chainId:e,multiChain:t})=>{let n=d(r=>r.chains);if(!n)throw new Error("No chains found in GrazProvider");let i=typeof e=="string"?[e]:e;switch(!0){case(!!t&&!!i):return i.map(r=>n.find(o=>o.chainId===r)).filter(Boolean);case(!t&&!!i):return [i.map(r=>n.find(o=>o.chainId===r)).filter(Boolean)[0]];case(!!t&&!i):return n;default:return [n[0]]}},q=(e,t,n)=>l(void 0,null,function*(){let i=d.getState().multiChainFetchConcurrency;if(e){let o=yield Me(t,n,{concurrency:i});return Object.fromEntries(o.map((s,a)=>[t[a].chainId,s]))}return yield n(t[0])}),pt=(e,t,n)=>{if(e){let r=t.map(n);return Object.fromEntries(r.map((o,s)=>[t[s].chainId,o]))}return n(t[0])};var ve=e=>{let t=K({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),n=react.useMemo(()=>["USE_STARGATE_CLIENT",t],[t]);return reactQuery.useQuery({queryKey:n,queryFn:r=>l(void 0,[r],function*({queryKey:[,i]}){if(i.length<1)throw new Error("No chains found");return yield q(!!(e!=null&&e.multiChain),i,s=>l(void 0,null,function*(){var m;let a=(m=d.getState().chainsConfig)==null?void 0:m[s.chainId],c={url:s.rpc,headers:E({},(a==null?void 0:a.rpcHeaders)||{})};return yield stargate.StargateClient.connect(c)}))}),enabled:!!t&&t.length>0&&((e==null?void 0:e.enabled)!==void 0?!!e.enabled:!0),refetchOnWindowFocus:!1})},Re=e=>{let t=K({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),n=react.useMemo(()=>["USE_COSMWASM_CLIENT",t],[t]);return reactQuery.useQuery({queryKey:n,queryFn:r=>l(void 0,[r],function*({queryKey:[,i]}){if(i.length<1)throw new Error("No chains found");return yield q(!!(e!=null&&e.multiChain),i,s=>l(void 0,null,function*(){var m;let a=(m=d.getState().chainsConfig)==null?void 0:m[s.chainId],c={url:s.rpc,headers:E({},(a==null?void 0:a.rpcHeaders)||{})};return yield cosmwasmStargate.CosmWasmClient.connect(c)}))}),enabled:!!t&&t.length>0&&((e==null?void 0:e.enabled)!==void 0?!!e.enabled:!0),refetchOnWindowFocus:!1})},me=({type:e,chainId:t,multiChain:n,enabled:i})=>{let r=K({chainId:t,multiChain:n}),o=react.useMemo(()=>["USE_TENDERMINT_CLIENT",e,r],[e,r]);return reactQuery.useQuery({queryKey:o,queryFn:c=>l(void 0,[c],function*({queryKey:[,s,a]}){if(a.length<1)throw new Error("No chains found");return yield q(!!n,a,m=>l(void 0,null,function*(){var T;let S=(T=d.getState().chainsConfig)==null?void 0:T[m.chainId],w={url:m.rpc,headers:E({},(S==null?void 0:S.rpcHeaders)||{})};return yield (s==="tm37"?tendermintRpc.Tendermint37Client:tendermintRpc.Tendermint34Client).connect(w)}))}),enabled:!!r&&r.length>0&&(i!==void 0?!!i:!0),refetchOnWindowFocus:!1})};var Di=()=>d(e=>({walletType:e.walletType,isCosmostation:e.walletType==="cosmostation",isCosmostationMobile:e.walletType==="wc_cosmostation_mobile",isKeplr:e.walletType==="keplr",isKeplrMobile:e.walletType==="wc_keplr_mobile",isLeap:e.walletType==="leap",isLeapMobile:e.walletType==="wc_leap_mobile",isVectis:e.walletType==="vectis",isWalletConnect:e.walletType==="walletconnect",isMetamaskSnapLeap:e.walletType==="metamask_snap_leap",isStation:e.walletType==="station"}),shallow.shallow),pe=e=>{let n=["USE_CHECK_WALLET",d(r=>e||r.walletType)];return reactQuery.useQuery(n,({queryKey:[,r]})=>_(r))};var H=e=>{let t=d(a=>a.walletType),n=y(a=>a.activeChainIds),i=K({chainId:e!=null&&e.chainId?e.chainId:n||void 0,multiChain:e==null?void 0:e.multiChain}),r=y(a=>a.accounts),o=y(a=>a.status);return react.useEffect(()=>y.subscribe(a=>a.status,(a,c)=>{var u,m,S;if(a==="connected"){let{accounts:w,activeChainIds:h}=y.getState(),{chains:b}=d.getState(),{walletType:T}=d.getState();if(!w||!h||!b)return (u=e==null?void 0:e.onDisconnect)==null?void 0:u.call(e);(m=e==null?void 0:e.onConnect)==null||m.call(e,{accounts:w,chains:h.map(W=>b.find(k=>k.chainId===W)),walletType:T,isReconnect:c==="reconnecting"});}a==="disconnected"&&((S=e==null?void 0:e.onDisconnect)==null||S.call(e));}),[e]),{data:react.useMemo(()=>r?pt(!!(e!=null&&e.multiChain),i,a=>r[a.chainId]):void 0,[r,i,e==null?void 0:e.multiChain]),isConnected:o==="connected",isConnecting:o==="connecting",isDisconnected:o==="disconnected",isReconnecting:o==="reconnecting",isLoading:o==="connecting"||o==="reconnecting",walletType:o==="connected"?t:void 0,reconnect:F,status:o}},Yt=e=>{let t=K({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),{data:n}=H(),i=(e==null?void 0:e.bech32Address)||(n==null?void 0:n.bech32Address),{data:r}=ve({chainId:t.map(s=>s.chainId),multiChain:!0,enabled:((e==null?void 0:e.enabled)===void 0?!0:e.enabled)&&!!i}),o=react.useMemo(()=>["USE_ALL_BALANCES",r,t,i,e==null?void 0:e.chainId],[i,e==null?void 0:e.chainId,t,r]);return reactQuery.useQuery(o,u=>l(void 0,[u],function*({queryKey:[,s,a,c]}){if(!c)throw new Error("address is not defined");return yield q(!!(e!=null&&e.multiChain),a,S=>l(void 0,null,function*(){let w=s==null?void 0:s[S.chainId];if(!w)throw new Error(`Client is not ready ${S.chainId}`);return yield w.getAllBalances(encoding.toBech32(S.bech32Config.bech32PrefixAccAddr,encoding.fromBech32(c).data))}))}),{enabled:!!i&&!!t&&t.length>0&&!de(r)&&((e==null?void 0:e.enabled)===void 0?!0:e.enabled),refetchOnMount:!1,refetchOnReconnect:!0,refetchOnWindowFocus:!1})},Yi=e=>{let t=K({chainId:e.chainId}),{data:n}=H({chainId:e.chainId}),i=e.bech32Address||(n==null?void 0:n.bech32Address),{data:r,refetch:o}=Yt({chainId:t.map(c=>c.chainId),bech32Address:i,enabled:!!i&&(e.enabled===void 0?!0:e.enabled)}),s=["USE_BALANCE",e.denom,r,t,i,e.chainId],a=reactQuery.useQuery(s,({queryKey:[,c,u]})=>u==null?void 0:u.find(m=>m.denom===c),{enabled:!!r&&!!(r!=null&&r.length)&&(e.enabled===void 0?!0:e.enabled)});return N(E({},a),{refetch:c=>l(void 0,null,function*(){return yield o(),a.refetch(c)})})},Ji=({onError:e,onLoading:t,onSuccess:n}={})=>{let r=reactQuery.useMutation(["USE_CONNECT",e,t,n],ee,{onError:(s,a)=>Promise.resolve(e==null?void 0:e(s,a)),onMutate:t,onSuccess:s=>Promise.resolve(n==null?void 0:n(s))}),{data:o}=pe();return {connect:s=>r.mutate(s),connectAsync:s=>r.mutateAsync(s),error:r.error,isLoading:r.isLoading,isSuccess:r.isSuccess,isSupported:!!o,status:r.status}},Xi=({onError:e,onLoading:t,onSuccess:n}={})=>{let r=reactQuery.useMutation(["USE_DISCONNECT",e,t,n],Te,{onError:o=>Promise.resolve(e==null?void 0:e(o,void 0)),onMutate:t,onSuccess:()=>Promise.resolve(n==null?void 0:n(void 0))});return {disconnect:o=>r.mutate(o),disconnectAsync:o=>r.mutateAsync(o),error:r.error,isLoading:r.isLoading,isSuccess:r.isSuccess,status:r.status}},Zi=e=>{let t=K({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),n=d(r=>r.walletType),i=react.useMemo(()=>["USE_OFFLINE_SIGNERS",t,n],[t,n]);return reactQuery.useQuery({queryKey:i,queryFn:s=>l(void 0,[s],function*({queryKey:[,r,o]}){if(r.length<1)throw new Error("No chain found");if(!_(o))throw new Error(`${o} is not available`);return yield q(!!(e!=null&&e.multiChain),r,u=>l(void 0,null,function*(){return yield tt({chainId:u.chainId,walletType:o})}))}),enabled:!!t&&t.length>0&&!!n,refetchOnWindowFocus:!1})},er=e=>{let t=K({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),{data:n}=H(),{data:i}=ve({chainId:t.map(s=>s.chainId),multiChain:!0}),r=(e==null?void 0:e.bech32Address)||(n==null?void 0:n.bech32Address),o=react.useMemo(()=>["USE_BALANCE_STAKED",i,t,r],[t,r,i]);return reactQuery.useQuery(o,u=>l(void 0,[u],function*({queryKey:[,s,a,c]}){if(!c)throw new Error("address is not defined");return yield q(!!(e!=null&&e.multiChain),a,S=>l(void 0,null,function*(){var h;if(!s)throw new Error("Client is not ready");return yield (h=s[S.chainId])==null?void 0:h.getBalanceStaked(encoding.toBech32(S.bech32Config.bech32PrefixAccAddr,encoding.fromBech32(c).data))}))}),{enabled:!!r&&!!t&&t.length>0&&!!i,refetchOnMount:!1,refetchOnReconnect:!0,refetchOnWindowFocus:!1})};var cr=()=>y(e=>e.activeChainIds),Jt=()=>{var e;return (e=y(t=>t.activeChainIds))==null?void 0:e.map(t=>{var i;let n=(i=d.getState().chains)==null?void 0:i.find(r=>r.chainId===t);if(n)return n}).filter(Boolean)},lr=({denom:e})=>{let t=Jt();return reactQuery.useQuery(["USE_ACTIVE_CHAIN_CURRENCY",e],({queryKey:[,r]})=>{var o;return (o=t==null?void 0:t.find(s=>s.currencies.find(a=>a.coinMinimalDenom===r)))==null?void 0:o.currencies.find(s=>s)})},ur=e=>{var r;let t=(r=e.status)!=null?r:"BOND_STATUS_BONDED",n=["USE_ACTIVE_CHAIN_VALIDATORS",e.queryClient,t];return reactQuery.useQuery(n,a=>l(void 0,[a],function*({queryKey:[,o,s]}){if(!o)throw new Error("Query client is not defined");return yield o.staking.validators(s)}),{enabled:typeof e.queryClient!="undefined"})},dr=()=>({data:d(t=>t.recentChainIds),clear:Ee}),mr=()=>{var t;return {data:(t=d(n=>n.recentChainIds))==null?void 0:t.map(n=>{var r;let i=(r=d.getState().chains)==null?void 0:r.find(o=>o.chainId===n);if(i)return i}).filter(Boolean),clear:Ee}},pr=({onError:e,onLoading:t,onSuccess:n}={})=>{let r=reactQuery.useMutation(["USE_SUGGEST_CHAIN",e,t,n],be,{onError:(o,s)=>Promise.resolve(e==null?void 0:e(o,s.chainInfo)),onMutate:o=>t==null?void 0:t(o.chainInfo),onSuccess:o=>Promise.resolve(n==null?void 0:n(o))});return {error:r.error,isLoading:r.isLoading,isSuccess:r.isSuccess,suggest:r.mutate,suggestAsync:r.mutateAsync,status:r.status}},fr=({onError:e,onLoading:t,onSuccess:n}={})=>{let r=reactQuery.useMutation(["USE_SUGGEST_CHAIN_AND_CONNECT",e,t,n],nt,{onError:(s,a)=>Promise.resolve(e==null?void 0:e(s,a)),onMutate:s=>t==null?void 0:t(s),onSuccess:s=>Promise.resolve(n==null?void 0:n(s))}),{data:o}=pe();return {error:r.error,isLoading:r.isLoading,isSuccess:r.isSuccess,isSupported:!!o,status:r.status,suggestAndConnect:r.mutate,suggestAndConnectAsync:r.mutateAsync}};var Ir=({onError:e,onLoading:t,onSuccess:n}={})=>{let{data:i}=H(),r=i==null?void 0:i.bech32Address,o=reactQuery.useMutation(["USE_SEND_TOKENS",e,t,n,r],s=>it(E({senderAddress:r},s)),{onError:(s,a)=>Promise.resolve(e==null?void 0:e(s,a)),onMutate:t,onSuccess:s=>Promise.resolve(n==null?void 0:n(s))});return {error:o.error,isLoading:o.isLoading,isSuccess:o.isSuccess,sendTokens:o.mutate,sendTokensAsync:o.mutateAsync,status:o.status}},Tr=({onError:e,onLoading:t,onSuccess:n}={})=>{let{data:i}=H(),r=i==null?void 0:i.bech32Address,o=reactQuery.useMutation(["USE_SEND_IBC_TOKENS",e,t,n,r],s=>rt(E({senderAddress:r},s)),{onError:(s,a)=>Promise.resolve(e==null?void 0:e(s,a)),onMutate:t,onSuccess:s=>Promise.resolve(n==null?void 0:n(s))});return {error:o.error,isLoading:o.isLoading,isSuccess:o.isSuccess,sendIbcTokens:o.mutate,sendIbcTokensAsync:o.mutateAsync,status:o.status}},Er=({codeId:e,onError:t,onLoading:n,onSuccess:i})=>{let{data:r}=H(),o=r==null?void 0:r.bech32Address,a=reactQuery.useMutation(["USE_INSTANTIATE_CONTRACT",t,n,i,e,o],c=>{var m;if(!o)throw new Error("senderAddress is undefined");let u=N(E({},c),{fee:(m=c.fee)!=null?m:"auto",senderAddress:o,codeId:e});return st(u)},{onError:(c,u)=>Promise.resolve(t==null?void 0:t(c,u)),onMutate:n,onSuccess:c=>Promise.resolve(i==null?void 0:i(c))});return {error:a.error,isLoading:a.isLoading,isSuccess:a.isSuccess,instantiateContract:a.mutate,instantiateContractAsync:a.mutateAsync,status:a.status}},br=({contractAddress:e,onError:t,onLoading:n,onSuccess:i})=>{let{data:r}=H(),o=r==null?void 0:r.bech32Address,a=reactQuery.useMutation(["USE_EXECUTE_CONTRACT",t,n,i,e,o],c=>{var m,S,w;if(!o)throw new Error("senderAddress is undefined");let u=N(E({},c),{fee:(m=c.fee)!=null?m:"auto",senderAddress:o,contractAddress:e,memo:(S=c.memo)!=null?S:"",funds:(w=c.funds)!=null?w:[]});return at(u)},{onError:(c,u)=>Promise.resolve(t==null?void 0:t(c,u)),onMutate:n,onSuccess:c=>Promise.resolve(i==null?void 0:i(c))});return {error:a.error,isLoading:a.isLoading,isSuccess:a.isSuccess,executeContract:a.mutate,executeContractAsync:a.mutateAsync,status:a.status}},Or=e=>{let{data:t}=Re();return reactQuery.useQuery(["USE_QUERY_SMART",e==null?void 0:e.address,e==null?void 0:e.queryMsg,t],({queryKey:[,i]})=>{if(!(e!=null&&e.address)||!e.queryMsg)throw new Error("address or queryMsg undefined");return ct(e.address,e.queryMsg,t)},{enabled:!!(e!=null&&e.address)&&!!(e!=null&&e.queryMsg)&&!!t})},Mr=e=>{let{data:t}=Re(),n=["USE_QUERY_RAW",e==null?void 0:e.key,e==null?void 0:e.address,t];return reactQuery.useQuery(n,({queryKey:[,r]})=>{if(!(e!=null&&e.address)||!e.key)throw new Error("address or key undefined");return lt(e.address,e.key,t)},{enabled:!!(e!=null&&e.address)&&!!(e!=null&&e.key)&&!!t})};function Ur(e){let t=K({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),n=d(o=>o.walletType),i=y(o=>o.activeChainIds),r=react.useMemo(()=>["USE_STARGATE_SIGNING_CLIENT",t,n,e,i],[i,e,t,n]);return reactQuery.useQuery({queryKey:r,queryFn:a=>l(this,[a],function*({queryKey:[,o,s]}){if(o.length<1)throw new Error("No chains found");return yield q(!!(e!=null&&e.multiChain),o,u=>l(this,null,function*(){var T,W;if(!(i!=null&&i.includes(u.chainId)))return;if(!_(s))throw new Error(`${s} is not available`);let S=yield (()=>l(this,null,function*(){switch(e==null?void 0:e.offlineSigner){case"offlineSigner":return R(s).getOfflineSigner(u.chainId);case"offlineSignerAuto":return R(s).getOfflineSignerAuto(u.chainId);case"offlineSignerOnlyAmino":return R(s).getOfflineSignerOnlyAmino(u.chainId);default:return R(s).getOfflineSignerAuto(u.chainId)}}))(),w=(T=d.getState().chainsConfig)==null?void 0:T[u.chainId],h={url:u.rpc,headers:E({},(w==null?void 0:w.rpcHeaders)||{})};return (e==null?void 0:e.multiChain)===!0&&e.opts,yield stargate.SigningStargateClient.connectWithSigner(h,S,e!=null&&e.multiChain?(W=e.opts)==null?void 0:W[u.chainId]:e==null?void 0:e.opts)}))}),enabled:!!t&&t.length>0&&!!n&&((e==null?void 0:e.enabled)!==void 0?!!e.enabled:!0),refetchOnWindowFocus:!1})}function qr(e){let t=K({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),n=d(o=>o.walletType),i=y(o=>o.activeChainIds),r=react.useMemo(()=>["USE_COSMWASM_SIGNING_CLIENT",t,n,e,i],[i,e,t,n]);return reactQuery.useQuery({queryKey:r,queryFn:a=>l(this,[a],function*({queryKey:[,o,s]}){if(o.length<1)throw new Error("No chains found");return yield q(!!(e!=null&&e.multiChain),o,u=>l(this,null,function*(){var W,k;if(!(i!=null&&i.includes(u.chainId)))return;if(!_(s))throw new Error(`${s} is not available`);let S=yield (()=>l(this,null,function*(){switch(e==null?void 0:e.offlineSigner){case"offlineSigner":return R(s).getOfflineSigner(u.chainId);case"offlineSignerAuto":return R(s).getOfflineSignerAuto(u.chainId);case"offlineSignerOnlyAmino":return R(s).getOfflineSignerOnlyAmino(u.chainId);default:return R(s).getOfflineSignerAuto(u.chainId)}}))(),w=(W=d.getState().chainsConfig)==null?void 0:W[u.chainId],h={url:u.rpc,headers:E({},(w==null?void 0:w.rpcHeaders)||{})},b=w!=null&&w.gas?stargate.GasPrice.fromString(`${w.gas.price}${w.gas.denom}`):void 0;return yield cosmwasmStargate.SigningCosmWasmClient.connectWithSigner(h,S,E({gasPrice:b},e!=null&&e.multiChain?(k=e.opts)==null?void 0:k[u.chainId]:(e==null?void 0:e.opts)||{}))}))}),enabled:!!t&&t.length>0&&!!n&&((e==null?void 0:e.enabled)!==void 0?!!e.enabled:!0),refetchOnWindowFocus:!1})}function Gr(e){let t=K({chainId:e.chainId,multiChain:e.multiChain}),n=d(s=>s.walletType),i=y(s=>s.activeChainIds),r=react.useMemo(()=>["USE_STARGATE_TM_SIGNING_CLIENT",t,n,e,i],[i,e,t,n]),{data:o}=me({type:e.type,chainId:e.chainId,multiChain:e.multiChain});return reactQuery.useQuery({queryKey:r,queryFn:c=>l(this,[c],function*({queryKey:[,s,a]}){if(s.length<1)throw new Error("No chains found");return yield q(!!e.multiChain,s,m=>l(this,null,function*(){var T;if(!(i!=null&&i.includes(m.chainId)))return;if(!_(a))throw new Error(`${a} is not available`);if(!o)throw new Error("No tendermint client found");let w=yield (()=>l(this,null,function*(){switch(e.offlineSigner){case"offlineSigner":return R(a).getOfflineSigner(m.chainId);case"offlineSignerAuto":return R(a).getOfflineSignerAuto(m.chainId);case"offlineSignerOnlyAmino":return R(a).getOfflineSignerOnlyAmino(m.chainId);default:return R(a).getOfflineSignerAuto(m.chainId)}}))(),h=e.multiChain?o[m.chainId]:o;return yield stargate.SigningStargateClient.createWithSigner(h,w,e.multiChain?(T=e.opts)==null?void 0:T[m.chainId]:e.opts)}))}),enabled:!!t&&t.length>0&&!!n&&!!o&&(e.enabled!==void 0?!!e.enabled:!0),refetchOnWindowFocus:!1})}function Fr(e){let t=K({chainId:e.chainId,multiChain:e.multiChain}),n=d(a=>a.walletType),i=y(a=>a.activeChainIds),r=react.useMemo(()=>["USE_COSMWASM_TM_SIGNING_CLIENT",t,n,e,i],[i,e,t,n]),{data:o}=me({type:e.type,chainId:e.chainId,multiChain:!1,enabled:!e.multiChain}),{data:s}=me({type:e.type,chainId:e.chainId,multiChain:!0,enabled:!!e.multiChain});return reactQuery.useQuery({queryKey:r,queryFn:u=>l(this,[u],function*({queryKey:[,a,c]}){if(a.length<1)throw new Error("No chains found");return yield q(!!e.multiChain,a,S=>l(this,null,function*(){var C,A;if(!(i!=null&&i.includes(S.chainId)))return;if(!_(c))throw new Error(`${c} is not available`);let h=yield (()=>l(this,null,function*(){switch(e.offlineSigner){case"offlineSigner":return R(c).getOfflineSigner(S.chainId);case"offlineSignerAuto":return R(c).getOfflineSignerAuto(S.chainId);case"offlineSignerOnlyAmino":return R(c).getOfflineSignerOnlyAmino(S.chainId);default:return R(c).getOfflineSignerAuto(S.chainId)}}))(),b=(C=d.getState().chainsConfig)==null?void 0:C[S.chainId],T=b!=null&&b.gas?stargate.GasPrice.fromString(`${b.gas.price}${b.gas.denom}`):void 0,W=e.multiChain?s==null?void 0:s[S.chainId]:o;if(!W)throw new Error("No tendermint client found");return yield cosmwasmStargate.SigningCosmWasmClient.createWithSigner(W,h,E({gasPrice:T},e.multiChain?(A=e.opts)==null?void 0:A[S.chainId]:e.opts||{}))}))}),enabled:!!t&&t.length>0&&!!n&&(!!o||!de(s))&&(e.enabled!==void 0?!!e.enabled:!0),refetchOnWindowFocus:!1})}var Tt=({children:e})=>{let[t,n]=react.useState(!1);return react.useEffect(()=>{n(!0);},[]),jsxRuntime.jsx(jsxRuntime.Fragment,{children:t?e:null})};var nn=()=>{let e=typeof window!="undefined"&&window.sessionStorage.getItem(X)==="Active",{_reconnect:t,_onReconnectFailed:n,_reconnectConnector:i}=d(),{activeChainIds:r,wcSignClients:o}=y(),s=_(i||void 0);return react.useEffect(()=>{if(i){if(!s)return;e&&r?F({onError:n}):!e&&t&&F({onError:n});}},[s]),react.useEffect(()=>{var a,c,u,m,S,w,h,b,T,W,k,C;if(i){if(!s)return;i==="cosmostation"&&((c=(a=se()).subscription)==null||c.call(a,()=>{F({onError:n});})),i==="keplr"&&((m=(u=ae()).subscription)==null||m.call(u,()=>{F({onError:n});})),i==="leap"&&((w=(S=ce()).subscription)==null||w.call(S,()=>{F({onError:n});})),i==="vectis"&&((b=(h=ue()).subscription)==null||b.call(h,()=>{F({onError:n});})),i==="walletconnect"&&o.has("walletconnect")&&((W=(T=j()).subscription)==null||W.call(T,()=>{F({onError:n});})),i==="station"&&((C=(k=le()).subscription)==null||C.call(k,()=>{F({onError:n});}));}},[i,o,s]),null},bt=()=>(nn(),null);var sn=new reactQuery.QueryClient({}),fs=i=>{var r=i,{children:e,grazOptions:t}=r,n=Ue(r,["children","grazOptions"]);return ot(t),jsxRuntime.jsx(reactQuery.QueryClientProvider,N(E({client:sn},n),{children:jsxRuntime.jsxs(Tt,{children:[e,jsxRuntime.jsx(bt,{})]})}),"graz-provider")};

exports.GrazEvents = bt;
exports.GrazProvider = fs;
exports.WALLET_TYPES = Ge;
exports.WalletType = qe;
exports.checkWallet = _;
exports.clearRecentChain = Ee;
exports.clearSession = z;
exports.configureGraz = ot;
exports.connect = ee;
exports.defineChainInfo = ui;
exports.defineChains = li;
exports.disconnect = Te;
exports.executeContract = at;
exports.getAvailableWallets = Ko;
exports.getCosmostation = se;
exports.getKeplr = ae;
exports.getLeap = ce;
exports.getMetamaskSnapLeap = $e;
exports.getOfflineSigners = tt;
exports.getQueryRaw = lt;
exports.getQuerySmart = ct;
exports.getRecentChainIds = Xo;
exports.getRecentChains = Zo;
exports.getVectis = ue;
exports.getWCCosmostation = Je;
exports.getWCKeplr = Xe;
exports.getWCLeap = Ze;
exports.getWallet = R;
exports.getWalletConnect = j;
exports.instantiateContract = st;
exports.isWalletConnect = et;
exports.reconnect = F;
exports.sendIbcTokens = rt;
exports.sendTokens = it;
exports.suggestChain = be;
exports.suggestChainAndConnect = nt;
exports.useAccount = H;
exports.useActiveChainCurrency = lr;
exports.useActiveChainIds = cr;
exports.useActiveChains = Jt;
exports.useActiveWalletType = Di;
exports.useBalance = Yi;
exports.useBalanceStaked = er;
exports.useBalances = Yt;
exports.useCheckWallet = pe;
exports.useConnect = Ji;
exports.useCosmWasmClient = Re;
exports.useCosmWasmSigningClient = qr;
exports.useCosmWasmTmSigningClient = Fr;
exports.useDisconnect = Xi;
exports.useExecuteContract = br;
exports.useGrazEvents = nn;
exports.useInstantiateContract = Er;
exports.useOfflineSigners = Zi;
exports.useQueryClientValidators = ur;
exports.useQueryRaw = Mr;
exports.useQuerySmart = Or;
exports.useRecentChainIds = dr;
exports.useRecentChains = mr;
exports.useSendIbcTokens = Tr;
exports.useSendTokens = Ir;
exports.useStargateClient = ve;
exports.useStargateSigningClient = Ur;
exports.useStargateTmSigningClient = Gr;
exports.useSuggestChain = pr;
exports.useSuggestChainAndConnect = fr;
exports.useTendermintClient = me;
