import { fromBech32, toBech32 } from '@cosmjs/encoding';
import { create } from 'zustand';
import { createJSONStorage, subscribeWithSelector, persist } from 'zustand/middleware';
import _t from 'long';
import { SignClient } from '@walletconnect/sign-client';
import { getSdkError } from '@walletconnect/utils';
import { QueryClient, useQuery, useMutation, QueryClientProvider } from '@tanstack/react-query';
import { useMemo, useEffect, useState } from 'react';
import { CosmWasmClient, SigningCosmWasmClient } from '@cosmjs/cosmwasm-stargate';
import { StargateClient, SigningStargateClient, GasPrice } from '@cosmjs/stargate';
import { Tendermint37Client, Tendermint34Client } from '@cosmjs/tendermint-rpc';
import { shallow } from 'zustand/shallow';
import { jsx, jsxs, Fragment } from 'react/jsx-runtime';

var Wt=Object.defineProperty,vt=Object.defineProperties;var Rt=Object.getOwnPropertyDescriptors;var se=Object.getOwnPropertySymbols;var Ke=Object.prototype.hasOwnProperty,Ue=Object.prototype.propertyIsEnumerable;var Le=(e,t,n)=>t in e?Wt(e,t,{enumerable:!0,configurable:!0,writable:!0,value:n}):e[t]=n,E=(e,t)=>{for(var n in t||(t={}))Ke.call(t,n)&&Le(e,n,t[n]);if(se)for(var n of se(t))Ue.call(t,n)&&Le(e,n,t[n]);return e},B=(e,t)=>vt(e,Rt(t));var qe=(e,t)=>{var n={};for(var i in e)Ke.call(e,i)&&t.indexOf(i)<0&&(n[i]=e[i]);if(e!=null&&se)for(var i of se(e))t.indexOf(i)<0&&Ue.call(e,i)&&(n[i]=e[i]);return n};var l=(e,t,n)=>new Promise((i,r)=>{var o=c=>{try{a(n.next(c));}catch(u){r(u);}},s=c=>{try{a(n.throw(c));}catch(u){r(u);}},a=c=>c.done?i(c.value):Promise.resolve(c.value).then(o,s);a((n=n.apply(e,t)).next());});var Z="graz-reconnect-session";var Ge=(m=>(m.KEPLR="keplr",m.LEAP="leap",m.VECTIS="vectis",m.COSMOSTATION="cosmostation",m.WALLETCONNECT="walletconnect",m.WC_KEPLR_MOBILE="wc_keplr_mobile",m.WC_LEAP_MOBILE="wc_leap_mobile",m.WC_COSMOSTATION_MOBILE="wc_cosmostation_mobile",m.METAMASK_SNAP_LEAP="metamask_snap_leap",m.STATION="station",m))(Ge||{}),Fe=["keplr","leap","vectis","cosmostation","walletconnect","wc_keplr_mobile","wc_leap_mobile","wc_cosmostation_mobile","metamask_snap_leap","station"];var Pt={recentChainIds:null,chains:null,chainsConfig:null,multiChainFetchConcurrency:3,walletType:"keplr",walletConnect:{options:null,web3Modal:null},_notFoundFn:()=>null,_onReconnectFailed:()=>null,_reconnect:!1,_reconnectConnector:null},ee={accounts:null,activeChainIds:null,status:"disconnected",wcSignClients:new Map},Nt={name:"graz-session",version:2,partialize:e=>({accounts:e.accounts,activeChainIds:e.activeChainIds}),storage:createJSONStorage(()=>sessionStorage)},Bt={name:"graz-internal",partialize:e=>({recentChainIds:e.recentChainIds,_reconnect:e._reconnect,_reconnectConnector:e._reconnectConnector}),version:2},y=create(subscribeWithSelector(persist(()=>ee,Nt))),d=create(subscribeWithSelector(persist(()=>Pt,Bt)));var ae=()=>{if(typeof window.cosmostation.providers.keplr!="undefined"){let e=window.cosmostation.providers.keplr;return Object.assign(e,{subscription:i=>{let r=()=>{Q(),i();};return window.cosmostation.cosmos.on("accountChanged",r),()=>{window.cosmostation.cosmos.off("accountChanged",r);}}})}throw d.getState()._notFoundFn(),new Error("window.cosmostation.providers.keplr is not defined")};var ce=()=>{if(typeof window.keplr!="undefined"){let e=window.keplr;return Object.assign(e,{subscription:i=>{let r=()=>{Q(),i();};return window.addEventListener("keplr_keystorechange",r),()=>{window.removeEventListener("keplr_keystorechange",r);}}})}throw d.getState()._notFoundFn(),new Error("window.keplr is not defined")};var le=()=>{if(typeof window.leap!="undefined"){let e=window.leap;return Object.assign(e,{subscription:i=>{let r=()=>{Q(),i();};return window.addEventListener("leap_keystorechange",r),()=>{window.removeEventListener("leap_keystorechange",r);}}})}throw d.getState()._notFoundFn(),new Error("window.leap is not defined")};var $e=e=>{let t=window.ethereum;if(t&&e){let n=()=>l(void 0,null,function*(){return yield t.request({method:"wallet_getSnaps"})}),i=C=>l(void 0,null,function*(){try{let A=yield n();return Object.values(A).find(x=>x.id===e.id&&(!C||x.version===C))}catch(A){return}}),r=()=>l(void 0,null,function*(){yield t.request({method:"wallet_requestSnaps",params:{[e.id]:e.params||{}}});}),o=()=>l(void 0,null,function*(){var _;let C=yield t.request({method:"web3_clientVersion"});if(!C.includes("MetaMask"))throw new Error("Metamask is not installed");let x=(_=C.split("MetaMask/v")[1])==null?void 0:_.split(".")[0];if(!(Number(x)>=11))throw new Error("Metamask Snap is not supported in this version");return (yield i())||(yield r()),!0}),s=C=>l(void 0,null,function*(){(yield i())||(yield r());}),a=(C,A,x)=>l(void 0,null,function*(){let N=yield t.request({method:"wallet_invokeSnap",params:{snapId:e.id,request:{method:"signDirect",params:{chainId:C,signerAddress:A,signDoc:x}}}}),L=x.accountNumber,_=new _t(L.low,L.high,L.unsigned);return {signature:N.signature,signed:B(E({},N.signed),{accountNumber:`${_.toString()}`,authInfoBytes:new Uint8Array(Object.values(N.signed.authInfoBytes)),bodyBytes:new Uint8Array(Object.values(N.signed.bodyBytes))})}}),c=(C,A,x)=>l(void 0,null,function*(){return yield t.request({method:"wallet_invokeSnap",params:{snapId:e.id,request:{method:"signAmino",params:{chainId:C,signerAddress:A,signDoc:x}}}})}),u=C=>l(void 0,null,function*(){let A=yield t.request({method:"wallet_invokeSnap",params:{snapId:e.id,request:{method:"getKey",params:{chainId:C}}}});if(!A)throw new Error("No response from Metamask");return A.pubKey=Uint8Array.from(Object.values(A.pubkey)),delete A.pubkey,E({},A)}),m=C=>l(void 0,null,function*(){let A=yield u(C);return {address:A.bech32Address,algo:A.algo,pubkey:A.pubKey}}),S=(...C)=>l(void 0,null,function*(){let[A,x,N,L]=C;return yield c(A,x,N)}),w=(...C)=>l(void 0,null,function*(){let[A,x,N]=C;return yield a(A,x,N)}),h=C=>({getAccounts:()=>l(void 0,null,function*(){return [yield m(C)]}),signDirect:(A,x)=>w(C,A,x)}),b=C=>({getAccounts:()=>l(void 0,null,function*(){return [yield m(C)]}),signAmino:(A,x)=>S(C,A,x)});return {enable:s,experimentalSuggestChain:(...C)=>l(void 0,null,function*(){yield o(),yield t.request({method:"wallet_invokeSnap",params:{snapId:e.id,request:{method:"suggestChain",params:{chainInfo:C[0]}}}});}),getKey:u,getOfflineSigner:C=>({getAccounts:()=>l(void 0,null,function*(){return [yield m(C)]}),signDirect:(A,x)=>w(C,A,x),signAmino:(A,x)=>S(C,A,x)}),getOfflineSignerAuto:C=>l(void 0,null,function*(){return (yield u(C)).isNanoLedger?b(C):h(C)}),getOfflineSignerOnlyAmino:b,init:o,signAmino:S,signDirect:w}}throw d.getState()._notFoundFn(),new Error("window.ethereum is not defined")};var He=()=>$e({id:"npm:@leapwallet/metamask-cosmos-snap"});var ue=()=>{if(typeof window.station!="undefined"){let e=window.station.keplr;return {subscription:o=>{let s=()=>{Q(),o();};return window.addEventListener("station_wallet_change",s),()=>{window.removeEventListener("station_wallet_change",s);}},getKey:o=>l(void 0,null,function*(){let s=yield e.getKey(o);return E({isKeystone:!1},s)}),getOfflineSigner:o=>{try{let s=e.getOfflineSignerOnlyAmino(o);return Object.assign(s,{signDirect:(u,m)=>{throw new Error("signDirect not supported by Station")}})}catch(s){throw console.error(s),s}},experimentalSuggestChain:o=>l(void 0,null,function*(){try{let s=Object.assign(o,{chainSymbolImageUrl:o.chainSymbolImageUrl||"",stakeCurrency:{coinDecimals:o.stakeCurrency.coinDecimals,coinDenom:o.stakeCurrency.coinDenom,coinImageUrl:o.stakeCurrency.coinImageUrl||"",coinMinimalDenom:o.stakeCurrency.coinMinimalDenom},currencies:o.currencies.map(a=>({coinDecimals:a.coinDecimals,coinDenom:a.coinDenom,coinImageUrl:a.coinImageUrl||"",coinMinimalDenom:a.coinMinimalDenom})),feeCurrencies:o.feeCurrencies.map(a=>{var c,u,m;return {coinDecimals:a.coinDecimals,coinDenom:a.coinDenom,coinImageUrl:a.coinImageUrl||"",coinMinimalDenom:a.coinMinimalDenom,gasPriceStep:{average:((c=a.gasPriceStep)==null?void 0:c.average)||0,high:((u=a.gasPriceStep)==null?void 0:u.high)||0,low:((m=a.gasPriceStep)==null?void 0:m.low)||0}}})});yield e.experimentalSuggestChain(s);}catch(s){throw console.error(s),s}}),enable:o=>e.enable(o),disable:o=>e.disable(o),getOfflineSignerAuto:o=>e.getOfflineSignerAuto(o),getOfflineSignerOnlyAmino:o=>e.getOfflineSignerOnlyAmino(o),signDirect:()=>e.signDirect(),signAmino:(o,s,a,c)=>e.signAmino(o,s,a)}}throw d.getState()._notFoundFn(),new Error("window.station is not defined")};var de=()=>{if(typeof window.vectis!="undefined"){let e=window.vectis.cosmos;return {enable:a=>e.enable(a),getOfflineSigner:a=>e.getOfflineSigner(a),getOfflineSignerAuto:a=>e.getOfflineSignerAuto(a),getKey:a=>l(void 0,null,function*(){let c=yield e.getKey(a);return {address:fromBech32(c.address).data,algo:c.algo,bech32Address:c.address,name:c.name,pubKey:c.pubKey,isKeystone:!1,isNanoLedger:c.isNanoLedger}}),subscription:a=>{let c=()=>{Q(),a();};return window.addEventListener("vectis_accountChanged",c),()=>{window.removeEventListener("vectis_accountChanged",c);}},getOfflineSignerOnlyAmino:(...a)=>e.getOfflineSignerAmino(...a),experimentalSuggestChain:(...a)=>l(void 0,null,function*(){let[c]=a,u=B(E({},c),{rpcUrl:c.rpc,restUrl:c.rest,prettyName:c.chainName.replace(" ",""),bech32Prefix:c.bech32Config.bech32PrefixAccAddr});return e.suggestChains([u])}),signDirect:(...a)=>l(void 0,null,function*(){var m;let{1:c,2:u}=a;return e.signDirect(c,{bodyBytes:u.bodyBytes||Uint8Array.from([]),authInfoBytes:u.authInfoBytes||Uint8Array.from([]),accountNumber:_t.fromString(((m=u.accountNumber)==null?void 0:m.toString())||"",!1),chainId:u.chainId||""})}),signAmino:(...a)=>l(void 0,null,function*(){let{1:c,2:u}=a;return e.signAmino(c,u)})}}throw d.getState()._notFoundFn(),new Error("window.vectis is not defined")};var j=()=>typeof window!="undefined"?!!(window.matchMedia("(pointer:coarse)").matches||/Android|webOS|iPhone|iPad|iPod|BlackBerry|Opera Mini/u.test(navigator.userAgent)):!1,Ve=()=>j()&&navigator.userAgent.toLowerCase().includes("android"),Ye=()=>j()&&(navigator.userAgent.toLowerCase().includes("iphone")||navigator.userAgent.toLowerCase().includes("ipad"));var Ie=(e,t,n=new Error("Promise timed out"))=>{let i=new Promise((r,o)=>{setTimeout(()=>{o(n);},t);});return Promise.race([e,i])};var $=e=>{var _,ne,Pe;if(!((Pe=(ne=(_=d.getState().walletConnect)==null?void 0:_.options)==null?void 0:ne.projectId)!=null&&Pe.trim()))throw new Error("walletConnect.options.projectId is not defined");let t=(e==null?void 0:e.walletType)||"walletconnect",n=(e==null?void 0:e.encoding)||"base64",i=p=>{if(!e)return;let{appUrl:f,formatNativeUrl:g}=e;if(j()){if(Ve())if(!p)window.open(f.mobile.android,"_self","noreferrer noopener");else {let I=g(f.mobile.android,p,"android");window.open(I,"_self","noreferrer noopener");}if(Ye())if(!p)window.open(f.mobile.ios,"_self","noreferrer noopener");else {let I=g(f.mobile.ios,p,"ios");window.open(I,"_self","noreferrer noopener");}}},r=()=>{let{wcSignClients:p}=y.getState();if(!p.get(t))throw new Error("walletConnect.signClient is not defined");p.delete(t),y.setState({wcSignClients:p}),d.setState({_reconnect:!1,_reconnectConnector:null,recentChainIds:null});},o=p=>l(void 0,null,function*(){let{wcSignClients:f}=y.getState(),g=f.get(t);if(!g)throw new Error("walletConnect.signClient is not defined");if(!p)throw new Error("No wallet connect session");yield g.disconnect({topic:p,reason:getSdkError("USER_DISCONNECTED")}),yield c(g);}),s=p=>{try{let{wcSignClients:f}=y.getState(),g=f.get(t);if(!g)throw new Error("walletConnect.signClient is not defined");let I=g.session.getAll().at(-1);if(!I)return;if(!(I.expiry*1e3>Date.now()+1e3))throw o(I.topic),new Error("invalid session");try{let W=g.find({requiredNamespaces:{cosmos:{methods:["cosmos_getAccounts","cosmos_signAmino","cosmos_signDirect"],chains:p.map(q=>`cosmos:${q}`),events:["chainChanged","accountsChanged"]}}});if(!W.length)throw new Error("no session");return W.at(-1)}catch(W){if(!W.message.toLowerCase().includes("no matching key"))throw W}return I}catch(f){if(!f.message.toLowerCase().includes("no matching key"))throw f}},a=p=>{try{return s(p)}catch(f){return}},c=p=>l(void 0,null,function*(){try{let f=p.core.pairing.pairings.getAll({active:!1});if(!f.length)return;yield Promise.all(f.map(g=>l(void 0,null,function*(){yield p.core.pairing.pairings.delete(g.topic,{code:7001,message:"clear pairing"});})));}catch(f){if(!f.message.toLowerCase().includes("no matching key"))throw f}}),u=()=>l(void 0,null,function*(){let{walletConnect:p}=d.getState();if(!(p!=null&&p.options))throw new Error("walletConnect.options is not defined");let{wcSignClients:f}=y.getState(),g=f.get(t);if(g)return g;let I=yield SignClient.init(p.options);return f.set(t,I),y.setState({wcSignClients:f}),I}),m=p=>{let{wcSignClients:f}=y.getState(),g=f.get(t);if(!g)return ()=>{};let I=R=>{let W=y.getState().accounts;if(R.params.event.name==="accountsChanged"&&W&&!Object.values(W).map(q=>q.bech32Address).includes(R.params.event.data[0])){let q=R.params.chainId.split(":")[1];q&&S([q]);}else p();};return g.events.on("session_delete",r),g.events.on("session_expire",r),g.events.on("session_event",I),()=>{g.events.off("session_delete",r),g.events.off("session_expire",r),g.events.off("session_event",I);}},S=p=>l(void 0,null,function*(){var oe;let f=typeof p=="string"?[p]:p,{wcSignClients:g}=y.getState(),I=g.get(t);if(!I)throw new Error("enable walletConnect.signClient is not defined");let{walletConnect:R,chains:W}=d.getState();if(!((oe=R==null?void 0:R.options)!=null&&oe.projectId))throw new Error("walletConnect.options.projectId is not defined");let{Web3Modal:q}=yield import('@web3modal/standalone'),H=new q(E({projectId:R.options.projectId,walletConnectVersion:2,enableExplorer:!1,explorerRecommendedWalletIds:"NONE"},R.web3Modal)),Y=a(f);if(!Y){let{uri:K,approval:J}=yield Ie(I.connect({requiredNamespaces:{cosmos:{methods:["cosmos_getAccounts","cosmos_signAmino","cosmos_signDirect"],chains:f.map(F=>`cosmos:${F}`),events:["chainChanged","accountsChanged"]}}}),15e3,new Error("Connection timeout"));if(!K)throw new Error("No wallet connect uri");e?i(K):yield H.openModal({uri:K});let ie=F=>l(void 0,null,function*(){return F.aborted?Promise.reject(new Error("User closed wallet connect")):new Promise((we,X)=>{J().then(Ne=>{let Be=Ne.sessionProperties;if(!Be)return X(new Error("No session properties"));let Ae=JSON.parse(String(Be.keys));if(Ae.length===0)return X(new Error("No accounts"));let _e=Ae[0];if(!_e)return X(new Error("No accounts"));let De={};return f.forEach(re=>{De[re]=B(E({},_e),{bech32Address:toBech32(W.find(xt=>xt.chainId===re).bech32Config.bech32PrefixAccAddr,fromBech32(Ae[0].bech32Address).data)});}),y.setState(re=>({accounts:E(E({},re.accounts||{}),De)})),we(Ne)}).catch(X),F.addEventListener("abort",()=>{X(new Error("User closed wallet connect"));},{once:!0});})});try{let F=new AbortController,we=F.signal;H.subscribeModal(X=>{X.open||F.abort();}),yield ie(we);}catch(F){if(H.closeModal(),!F.message.toLowerCase().includes("no matching key"))return Promise.reject(F)}return e||H.closeModal(),Promise.resolve()}try{yield Ie((()=>l(void 0,null,function*(){let K=yield h(f[0]),J={};f.forEach(ie=>{J[ie]=B(E({},K),{bech32Address:toBech32(W.find(F=>F.chainId===ie).bech32Config.bech32PrefixAccAddr,fromBech32(K.bech32Address).data)});}),y.setState({accounts:J});}))(),15e3,new Error("Connection timeout"));}catch(K){if(o(Y.topic),!K.message.toLowerCase().includes("no matching key"))throw K}}),w=p=>l(void 0,null,function*(){var W;let{wcSignClients:f}=y.getState(),g=f.get(t);if(!g)throw new Error("walletConnect.signClient is not defined");let I=(W=s([p]))==null?void 0:W.topic;if(!I)throw new Error("No wallet connect session");let R=yield g.request({topic:I,chainId:`cosmos:${p}`,request:{method:"cosmos_getAccounts",params:{}}});if(!R[0])throw new Error("No wallet connect account");return {address:R[0].address,algo:R[0].algo,pubkey:new Uint8Array(Buffer.from(R[0].pubkey,n))}}),h=p=>l(void 0,null,function*(){let{address:f,algo:g,pubkey:I}=yield w(p);return {address:fromBech32(f).data,algo:g,bech32Address:f,name:"",pubKey:I,isKeystone:!1,isNanoLedger:!1}}),b=(...p)=>l(void 0,null,function*(){var K,J;let[f,g,I]=p,{accounts:R,wcSignClients:W}=y.getState(),q=W.get(t);if(!q)throw new Error("walletConnect.signClient is not defined");if(!R)throw new Error("account is not defined");let H=(K=s([f]))==null?void 0:K.topic;if(!H)throw new Error("No wallet connect session");if(!I.bodyBytes)throw new Error("No bodyBytes");if(!I.authInfoBytes)throw new Error("No authInfoBytes");let Y={topic:H,chainId:`cosmos:${f}`,request:{method:"cosmos_signDirect",params:{signerAddress:g,signDoc:B(E({},I),{bodyBytes:Buffer.from(I.bodyBytes).toString(n),authInfoBytes:Buffer.from(I.authInfoBytes).toString(n),accountNumber:(J=I.accountNumber)==null?void 0:J.toString()})}}};return i(),yield q.request(Y)}),T=(...p)=>l(void 0,null,function*(){let[f,g,I]=p,{signature:R,signed:W}=yield b(f,g,I);return {signed:{chainId:W.chainId,accountNumber:_t.fromString(W.accountNumber,!1),authInfoBytes:new Uint8Array(Buffer.from(W.authInfoBytes,n)),bodyBytes:new Uint8Array(Buffer.from(W.bodyBytes,n))},signature:R}}),v=(...p)=>l(void 0,null,function*(){var K;let[f,g,I,R]=p,{wcSignClients:W}=y.getState(),q=W.get(t),{accounts:H}=y.getState();if(!q)throw new Error("walletConnect.signClient is not defined");if(!H)throw new Error("account is not defined");let Y=(K=s([f]))==null?void 0:K.topic;if(!Y)throw new Error("No wallet connect session");return i(),yield q.request({topic:Y,chainId:`cosmos:${f}`,request:{method:"cosmos_signDirect",params:{signerAddress:g,signDoc:I}}})}),P=(...p)=>l(void 0,null,function*(){let[f,g,I,R]=p;return yield v(f,g,I)}),C=p=>({getAccounts:()=>l(void 0,null,function*(){return [yield w(p)]}),signDirect:(f,g)=>T(p,f,g)}),A=p=>({getAccounts:()=>l(void 0,null,function*(){return [yield w(p)]}),signAmino:(f,g)=>P(p,f,g)});return {enable:S,disable:p=>l(void 0,null,function*(){var I;let{wcSignClients:f}=y.getState(),g=f.get(t);if(p===void 0){let R=g==null?void 0:g.session.getAll();R!==void 0&&(yield Promise.all(R.map(W=>o(W.topic))));}else typeof p=="string"?yield o((I=s([p]))==null?void 0:I.topic):yield Promise.all(p.map(R=>{var W;return o((W=s([R]))==null?void 0:W.topic)}));(g==null?void 0:g.session.getAll().length)===0&&r();}),experimentalSuggestChain:(...p)=>l(void 0,null,function*(){yield Promise.reject(new Error("WalletConnect does not support experimentalSuggestChain"));}),getKey:h,getOfflineSigner:p=>({getAccounts:()=>l(void 0,null,function*(){return [yield w(p)]}),signDirect:(f,g)=>T(p,f,g),signAmino:(f,g)=>P(p,f,g)}),getOfflineSignerAuto:p=>l(void 0,null,function*(){return (yield h(p)).isNanoLedger?A(p):C(p)}),getOfflineSignerOnlyAmino:A,signAmino:P,signDirect:T,subscription:m,init:u}};var Xe=()=>{var t,n,i;if(!((i=(n=(t=d.getState().walletConnect)==null?void 0:t.options)==null?void 0:n.projectId)!=null&&i.trim()))throw new Error("walletConnect.options.projectId is not defined");if(!j())throw new Error("WalletConnect Cosmostation mobile is only supported in mobile");let e={encoding:"hex",appUrl:{mobile:{ios:"cosmostation://",android:"cosmostation://"}},walletType:"wc_cosmostation_mobile",formatNativeUrl:(r,o,s)=>`${r.replaceAll("/","").replaceAll(":","")}://wc?${o}`};return $(e)};var Ze=()=>{var t,n,i;if(!((i=(n=(t=d.getState().walletConnect)==null?void 0:t.options)==null?void 0:n.projectId)!=null&&i.trim()))throw new Error("walletConnect.options.projectId is not defined");if(!j())throw new Error("WalletConnect Keplr mobile is only supported in mobile");let e={encoding:"base64",appUrl:{mobile:{ios:"keplrwallet://",android:"intent://"}},walletType:"wc_keplr_mobile",formatNativeUrl:(r,o,s)=>{let a=r.replaceAll("/","").replaceAll(":",""),c=encodeURIComponent(o);switch(s){case"ios":return `${a}://wcV2?${c}`;case"android":return `${a}://wcV2?${c}#Intent;package=com.chainapsis.keplr;scheme=keplrwallet;end;`;default:return `${a}://wc?uri=${c}`}}};return $(e)};var et=()=>{var t,n,i;if(!((i=(n=(t=d.getState().walletConnect)==null?void 0:t.options)==null?void 0:n.projectId)!=null&&i.trim()))throw new Error("walletConnect.options.projectId is not defined");if(!j())throw new Error("WalletConnect Leap mobile is only supported in mobile");let e={encoding:"base64",appUrl:{mobile:{ios:"leapcosmos://",android:"intent://"}},walletType:"wc_leap_mobile",formatNativeUrl:(r,o,s)=>{let a=r.replaceAll("/","").replaceAll(":",""),c=encodeURIComponent(o);switch(s){case"ios":return `${a}://wcV2?${c}`;case"android":return `${a}://wcV2?${c}#Intent;package=io.leapwallet.cosmos;scheme=leapwallet;end;`;default:return `${a}://wc?uri=${c}`}}};return $(e)};var D=(e=d.getState().walletType)=>{try{return k(e),!0}catch(t){return !1}},Q=()=>{window.sessionStorage.removeItem(Z),y.setState(ee);},k=(e=d.getState().walletType)=>{switch(e){case"keplr":return ce();case"leap":return le();case"cosmostation":return ae();case"vectis":return de();case"walletconnect":return $();case"wc_keplr_mobile":return Ze();case"wc_leap_mobile":return et();case"wc_cosmostation_mobile":return Xe();case"metamask_snap_leap":return He();case"station":return ue();default:throw new Error("Unknown wallet type")}},Uo=()=>Object.fromEntries(Fe.map(e=>[e,D(e)])),tt=e=>e==="walletconnect"||e==="wc_keplr_mobile"||e==="wc_leap_mobile"||e==="wc_cosmostation_mobile";var te=e=>l(void 0,null,function*(){var t;try{let{recentChainIds:n,chains:i,walletType:r}=d.getState(),o=(e==null?void 0:e.walletType)||r;if(!D(o))throw new Error(`${o} is not available`);let a=k(o),c=typeof(e==null?void 0:e.chainId)=="string"?[e.chainId]:(e==null?void 0:e.chainId)||n;if(!c)throw new Error("No last known connected chain, connect action requires chain ids");let u=i==null?void 0:i.map(h=>h.chainId);c.forEach(h=>{if(!(u!=null&&u.includes(h)))throw new Error(`Chain ${h} is not provided in GrazProvider`)}),y.setState(h=>{let b=d.getState()._reconnect||!!d.getState()._reconnectConnector||!!c;return h.activeChainIds&&c.filter(v=>{var P;return !((P=h.activeChainIds)!=null&&P.includes(v))}).length>0?{status:"connecting"}:b?{status:"reconnecting"}:{status:"connecting"}});let{accounts:m}=y.getState();if(yield (t=a.init)==null?void 0:t.call(a),yield a.enable(c),!tt(o)){let h=yield a.getKey(c[0]),b={};c.forEach(T=>{b[T]=B(E({},h),{bech32Address:toBech32(i.find(v=>v.chainId===T).bech32Config.bech32PrefixAccAddr,fromBech32(h.bech32Address).data)});}),y.setState(T=>({accounts:E(E({},T.accounts||{}),b)}));}d.setState(h=>({recentChainIds:[...h.recentChainIds||[],...c].filter((b,T,v)=>v.indexOf(b)===T)})),y.setState(h=>({activeChainIds:[...h.activeChainIds||[],...c].filter((b,T,v)=>v.indexOf(b)===T)})),d.setState({walletType:o,_reconnect:!!(e!=null&&e.autoReconnect),_reconnectConnector:o}),y.setState({status:"connected"}),typeof window!="undefined"&&window.sessionStorage.setItem(Z,"Active");let S=c.map(h=>i.find(b=>b.chainId===h));return {accounts:y.getState().accounts,walletType:o,chains:S}}catch(n){throw console.error("connect ",n),y.getState().accounts===null&&y.setState({status:"disconnected"}),y.getState().accounts&&y.getState().activeChainIds&&y.setState({status:"connected"}),n}}),Ee=e=>{typeof window!="undefined"&&window.sessionStorage.removeItem(Z);let t=typeof(e==null?void 0:e.chainId)=="string"?[e.chainId]:e==null?void 0:e.chainId;if(t){let n=y.getState().accounts;t.forEach(r=>{n==null||delete n[r];}),Object.values(n||{}).length===0?(y.setState(ee),d.setState({_reconnect:!1,_reconnectConnector:null,recentChainIds:null})):(y.setState(r=>{var o;return {activeChainIds:(o=r.activeChainIds)==null?void 0:o.filter(s=>!t.includes(s)),accounts:n}}),d.setState(r=>{var o;return {recentChainIds:(o=r.recentChainIds)==null?void 0:o.filter(s=>!t.includes(s))}}));}else y.setState(ee),d.setState({_reconnect:!1,_reconnectConnector:null,recentChainIds:null});return Promise.resolve()},z=e=>l(void 0,null,function*(){var r;let{recentChainIds:t,_reconnectConnector:n,_reconnect:i}=d.getState();try{let o=D(n||void 0);if(t&&o&&n)return yield te({chainId:t,walletType:n,autoReconnect:i})}catch(o){(r=e==null?void 0:e.onError)==null||r.call(e,o),Ee();}}),nt=e=>l(void 0,null,function*(){if(!(e!=null&&e.chainId))throw new Error("chainId is required");let{walletType:t}=d.getState(),n=e.walletType||t;if(!D(n))throw new Error(`${n} is not available`);let r=k(n),o=r.getOfflineSigner(e.chainId),s=r.getOfflineSignerOnlyAmino(e.chainId),a=yield r.getOfflineSignerAuto(e.chainId);return {offlineSigner:o,offlineSignerAmino:s,offlineSignerAuto:a}});var be=()=>{d.setState({recentChainIds:null});},Zo=()=>d.getState().recentChainIds,ei=()=>{var n;let{recentChainIds:e,chains:t}=d.getState();return (n=e==null?void 0:e.map(i=>t.find(r=>r.chainId===i)))!=null?n:null},Oe=n=>l(void 0,[n],function*({chainInfo:e,walletType:t}){return yield k(t).experimentalSuggestChain(e),e}),ot=e=>l(void 0,null,function*(){var i;let t=d.getState().walletType;return yield Oe({chainInfo:e.chainInfo,walletType:(i=e.walletType)!=null?i:t}),yield te({chainId:e.chainInfo.chainId,walletType:e.walletType,autoReconnect:e.autoReconnect})});var it=e=>(d.setState(t=>({walletConnect:e.walletConnect||t.walletConnect,walletType:e.defaultWallet||t.walletType,chains:e.chains,chainsConfig:e.chainsConfig||t.chainsConfig,multiChainFetchConcurrency:e.multiChainFetchConcurrency||t.multiChainFetchConcurrency,_notFoundFn:e.onNotFound||t._notFoundFn,_onReconnectFailed:e.onReconnectFailed||t._onReconnectFailed,_reconnect:e.autoReconnect===void 0?!0:e.autoReconnect||t._reconnect})),e);var rt=s=>l(void 0,[s],function*({signingClient:e,senderAddress:t,recipientAddress:n,amount:i,fee:r,memo:o}){if(!e)throw new Error("No connected account detected");if(!t)throw new Error("senderAddress is not defined");return e.sendTokens(t,n,i,r,o)}),st=m=>l(void 0,[m],function*({signingClient:e,senderAddress:t,recipientAddress:n,transferAmount:i,sourcePort:r,sourceChannel:o,timeoutHeight:s,timeoutTimestamp:a,fee:c,memo:u}){if(!e)throw new Error("Stargate signing client is not ready");if(!t)throw new Error("senderAddress is not defined");return e.sendIbcTokens(t,n,i,r,o,s,a,c,u)}),at=a=>l(void 0,[a],function*({signingClient:e,senderAddress:t,msg:n,fee:i,options:r,label:o,codeId:s}){if(!e)throw new Error("CosmWasm signing client is not ready");return e.instantiate(t,s,n,o,i,r)}),ct=a=>l(void 0,[a],function*({signingClient:e,senderAddress:t,msg:n,fee:i,contractAddress:r,funds:o,memo:s}){if(!e)throw new Error("CosmWasm signing client is not ready");return e.execute(t,r,n,i,s,o)}),lt=(e,t,n)=>l(void 0,null,function*(){if(!n)throw new Error("CosmWasm client is not ready");return yield n.queryContractSmart(e,t)}),ut=(e,t,n)=>{if(!n)throw new Error("CosmWasm client is not ready");let i=new TextEncoder().encode(t);return n.queryContractRaw(e,i)};var ui=e=>e,di=e=>e;var me=e=>e?Object.keys(e).length===0:!0;var Me=class extends Error{constructor(t){super(),this.name="AbortError",this.message=t;}},dt=e=>globalThis.DOMException===void 0?new Me(e):new DOMException(e),mt=e=>{let t=e.reason===void 0?dt("This operation was aborted."):e.reason;return t instanceof Error?t:dt(t)};function xe(o,s){return l(this,arguments,function*(e,t,{concurrency:n=Number.POSITIVE_INFINITY,stopOnError:i=!0,signal:r}={}){return new Promise((a,c)=>{if(e[Symbol.iterator]===void 0&&e[Symbol.asyncIterator]===void 0)throw new TypeError(`Expected \`input\` to be either an \`Iterable\` or \`AsyncIterable\`, got (${typeof e})`);if(typeof t!="function")throw new TypeError("Mapper function is required");if(!((Number.isSafeInteger(n)||n===Number.POSITIVE_INFINITY)&&n>=1))throw new TypeError(`Expected \`concurrency\` to be an integer from 1 and up or \`Infinity\`, got \`${n}\` (${typeof n})`);let u=[],m=[],S=new Map,w=!1,h=!1,b=!1,T=0,v=0,P=e[Symbol.iterator]===void 0?e[Symbol.asyncIterator]():e[Symbol.iterator](),C=x=>{w=!0,h=!0,c(x);};r&&(r.aborted&&C(mt(r)),r.addEventListener("abort",()=>{C(mt(r));}));let A=()=>l(this,null,function*(){if(h)return;let x=yield P.next(),N=v;if(v++,x.done){if(b=!0,T===0&&!h){if(!i&&m.length>0){C(new AggregateError(m));return}if(h=!0,S.size===0){a(u);return}let L=[];for(let[_,ne]of u.entries())S.get(_)!==pt&&L.push(ne);a(L);}return}T++,l(this,null,function*(){try{let L=yield x.value;if(h)return;let _=yield t(L,N);_===pt&&S.set(N,_),u[N]=_,T--,yield A();}catch(L){if(i)C(L);else {m.push(L),T--;try{yield A();}catch(_){C(_);}}}});});l(this,null,function*(){for(let x=0;x<n;x++){try{yield A();}catch(N){C(N);break}if(b||w)break}});})})}var pt=Symbol("skip");var U=({chainId:e,multiChain:t})=>{let n=d(r=>r.chains);if(!n)throw new Error("No chains found in GrazProvider");let i=typeof e=="string"?[e]:e;switch(!0){case(!!t&&!!i):return i.map(r=>n.find(o=>o.chainId===r)).filter(Boolean);case(!t&&!!i):return [i.map(r=>n.find(o=>o.chainId===r)).filter(Boolean)[0]];case(!!t&&!i):return n;default:return [n[0]]}},G=(e,t,n)=>l(void 0,null,function*(){let i=d.getState().multiChainFetchConcurrency;if(e){let o=yield xe(t,n,{concurrency:i});return Object.fromEntries(o.map((s,a)=>[t[a].chainId,s]))}return yield n(t[0])}),ft=(e,t,n)=>{if(e){let r=t.map(n);return Object.fromEntries(r.map((o,s)=>[t[s].chainId,o]))}return n(t[0])};var Re=e=>{let t=U({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),n=useMemo(()=>["USE_STARGATE_CLIENT",t],[t]);return useQuery({queryKey:n,queryFn:r=>l(void 0,[r],function*({queryKey:[,i]}){if(i.length<1)throw new Error("No chains found");return yield G(!!(e!=null&&e.multiChain),i,s=>l(void 0,null,function*(){var m;let a=(m=d.getState().chainsConfig)==null?void 0:m[s.chainId],c={url:s.rpc,headers:E({},(a==null?void 0:a.rpcHeaders)||{})};return yield StargateClient.connect(c)}))}),enabled:!!t&&t.length>0&&((e==null?void 0:e.enabled)!==void 0?!!e.enabled:!0),refetchOnWindowFocus:!1})},ke=e=>{let t=U({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),n=useMemo(()=>["USE_COSMWASM_CLIENT",t],[t]);return useQuery({queryKey:n,queryFn:r=>l(void 0,[r],function*({queryKey:[,i]}){if(i.length<1)throw new Error("No chains found");return yield G(!!(e!=null&&e.multiChain),i,s=>l(void 0,null,function*(){var m;let a=(m=d.getState().chainsConfig)==null?void 0:m[s.chainId],c={url:s.rpc,headers:E({},(a==null?void 0:a.rpcHeaders)||{})};return yield CosmWasmClient.connect(c)}))}),enabled:!!t&&t.length>0&&((e==null?void 0:e.enabled)!==void 0?!!e.enabled:!0),refetchOnWindowFocus:!1})},pe=({type:e,chainId:t,multiChain:n,enabled:i})=>{let r=U({chainId:t,multiChain:n}),o=useMemo(()=>["USE_TENDERMINT_CLIENT",e,r],[e,r]);return useQuery({queryKey:o,queryFn:c=>l(void 0,[c],function*({queryKey:[,s,a]}){if(a.length<1)throw new Error("No chains found");return yield G(!!n,a,m=>l(void 0,null,function*(){var T;let S=(T=d.getState().chainsConfig)==null?void 0:T[m.chainId],w={url:m.rpc,headers:E({},(S==null?void 0:S.rpcHeaders)||{})};return yield (s==="tm37"?Tendermint37Client:Tendermint34Client).connect(w)}))}),enabled:!!r&&r.length>0&&(i!==void 0?!!i:!0),refetchOnWindowFocus:!1})};var Li=()=>d(e=>({walletType:e.walletType,isCosmostation:e.walletType==="cosmostation",isCosmostationMobile:e.walletType==="wc_cosmostation_mobile",isKeplr:e.walletType==="keplr",isKeplrMobile:e.walletType==="wc_keplr_mobile",isLeap:e.walletType==="leap",isLeapMobile:e.walletType==="wc_leap_mobile",isVectis:e.walletType==="vectis",isWalletConnect:e.walletType==="walletconnect",isMetamaskSnapLeap:e.walletType==="metamask_snap_leap",isStation:e.walletType==="station"}),shallow),fe=e=>{let n=["USE_CHECK_WALLET",d(r=>e||r.walletType)];return useQuery(n,({queryKey:[,r]})=>D(r))};var V=e=>{let t=d(a=>a.walletType),n=y(a=>a.activeChainIds),i=U({chainId:e!=null&&e.chainId?e.chainId:n||void 0,multiChain:e==null?void 0:e.multiChain}),r=y(a=>a.accounts),o=y(a=>a.status);return useEffect(()=>y.subscribe(a=>a.status,(a,c)=>{var u,m,S;if(a==="connected"){let{accounts:w,activeChainIds:h}=y.getState(),{chains:b}=d.getState(),{walletType:T}=d.getState();if(!w||!h||!b)return (u=e==null?void 0:e.onDisconnect)==null?void 0:u.call(e);(m=e==null?void 0:e.onConnect)==null||m.call(e,{accounts:w,chains:h.map(v=>b.find(P=>P.chainId===v)),walletType:T,isReconnect:c==="reconnecting"});}a==="disconnected"&&((S=e==null?void 0:e.onDisconnect)==null||S.call(e));}),[e]),{data:useMemo(()=>r?ft(!!(e!=null&&e.multiChain),i,a=>r[a.chainId]):void 0,[r,i,e==null?void 0:e.multiChain]),isConnected:o==="connected",isConnecting:o==="connecting",isDisconnected:o==="disconnected",isReconnecting:o==="reconnecting",isLoading:o==="connecting"||o==="reconnecting",walletType:o==="connected"?t:void 0,reconnect:z,status:o}},Jt=e=>{let t=U({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),{data:n}=V(),i=(e==null?void 0:e.bech32Address)||(n==null?void 0:n.bech32Address),{data:r}=Re({chainId:t.map(s=>s.chainId),multiChain:!0,enabled:((e==null?void 0:e.enabled)===void 0?!0:e.enabled)&&!!i}),o=useMemo(()=>["USE_ALL_BALANCES",r,t,i,e==null?void 0:e.chainId],[i,e==null?void 0:e.chainId,t,r]);return useQuery(o,u=>l(void 0,[u],function*({queryKey:[,s,a,c]}){if(!c)throw new Error("address is not defined");return yield G(!!(e!=null&&e.multiChain),a,S=>l(void 0,null,function*(){let w=s==null?void 0:s[S.chainId];if(!w)throw new Error(`Client is not ready ${S.chainId}`);return yield w.getAllBalances(toBech32(S.bech32Config.bech32PrefixAccAddr,fromBech32(c).data))}))}),{enabled:!!i&&!!t&&t.length>0&&!me(r)&&((e==null?void 0:e.enabled)===void 0?!0:e.enabled),refetchOnMount:!1,refetchOnReconnect:!0,refetchOnWindowFocus:!1})},Ji=e=>{let t=U({chainId:e.chainId}),{data:n}=V({chainId:e.chainId}),i=e.bech32Address||(n==null?void 0:n.bech32Address),{data:r,refetch:o}=Jt({chainId:t.map(c=>c.chainId),bech32Address:i,enabled:!!i&&(e.enabled===void 0?!0:e.enabled)}),s=["USE_BALANCE",e.denom,r,t,i,e.chainId],a=useQuery(s,({queryKey:[,c,u]})=>u==null?void 0:u.find(m=>m.denom===c),{enabled:!!r&&!!(r!=null&&r.length)&&(e.enabled===void 0?!0:e.enabled)});return B(E({},a),{refetch:c=>l(void 0,null,function*(){return yield o(),a.refetch(c)})})},Xi=({onError:e,onLoading:t,onSuccess:n}={})=>{let r=useMutation(["USE_CONNECT",e,t,n],te,{onError:(s,a)=>Promise.resolve(e==null?void 0:e(s,a)),onMutate:t,onSuccess:s=>Promise.resolve(n==null?void 0:n(s))}),{data:o}=fe();return {connect:s=>r.mutate(s),connectAsync:s=>r.mutateAsync(s),error:r.error,isLoading:r.isLoading,isSuccess:r.isSuccess,isSupported:!!o,status:r.status}},Zi=({onError:e,onLoading:t,onSuccess:n}={})=>{let r=useMutation(["USE_DISCONNECT",e,t,n],Ee,{onError:o=>Promise.resolve(e==null?void 0:e(o,void 0)),onMutate:t,onSuccess:()=>Promise.resolve(n==null?void 0:n(void 0))});return {disconnect:o=>r.mutate(o),disconnectAsync:o=>r.mutateAsync(o),error:r.error,isLoading:r.isLoading,isSuccess:r.isSuccess,status:r.status}},er=e=>{let t=U({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),n=d(r=>r.walletType),i=useMemo(()=>["USE_OFFLINE_SIGNERS",t,n],[t,n]);return useQuery({queryKey:i,queryFn:s=>l(void 0,[s],function*({queryKey:[,r,o]}){if(r.length<1)throw new Error("No chain found");if(!D(o))throw new Error(`${o} is not available`);return yield G(!!(e!=null&&e.multiChain),r,u=>l(void 0,null,function*(){return yield nt({chainId:u.chainId,walletType:o})}))}),enabled:!!t&&t.length>0&&!!n,refetchOnWindowFocus:!1})},tr=e=>{let t=U({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),{data:n}=V(),{data:i}=Re({chainId:t.map(s=>s.chainId),multiChain:!0}),r=(e==null?void 0:e.bech32Address)||(n==null?void 0:n.bech32Address),o=useMemo(()=>["USE_BALANCE_STAKED",i,t,r],[t,r,i]);return useQuery(o,u=>l(void 0,[u],function*({queryKey:[,s,a,c]}){if(!c)throw new Error("address is not defined");return yield G(!!(e!=null&&e.multiChain),a,S=>l(void 0,null,function*(){var h;if(!s)throw new Error("Client is not ready");return yield (h=s[S.chainId])==null?void 0:h.getBalanceStaked(toBech32(S.bech32Config.bech32PrefixAccAddr,fromBech32(c).data))}))}),{enabled:!!r&&!!t&&t.length>0&&!!i,refetchOnMount:!1,refetchOnReconnect:!0,refetchOnWindowFocus:!1})};var lr=()=>y(e=>e.activeChainIds),Xt=()=>{var e;return (e=y(t=>t.activeChainIds))==null?void 0:e.map(t=>{var i;let n=(i=d.getState().chains)==null?void 0:i.find(r=>r.chainId===t);if(n)return n}).filter(Boolean)},ur=({denom:e})=>{let t=Xt();return useQuery(["USE_ACTIVE_CHAIN_CURRENCY",e],({queryKey:[,r]})=>{var o;return (o=t==null?void 0:t.find(s=>s.currencies.find(a=>a.coinMinimalDenom===r)))==null?void 0:o.currencies.find(s=>s)})},dr=e=>{var r;let t=(r=e.status)!=null?r:"BOND_STATUS_BONDED",n=["USE_ACTIVE_CHAIN_VALIDATORS",e.queryClient,t];return useQuery(n,a=>l(void 0,[a],function*({queryKey:[,o,s]}){if(!o)throw new Error("Query client is not defined");return yield o.staking.validators(s)}),{enabled:typeof e.queryClient!="undefined"})},mr=()=>({data:d(t=>t.recentChainIds),clear:be}),pr=()=>{var t;return {data:(t=d(n=>n.recentChainIds))==null?void 0:t.map(n=>{var r;let i=(r=d.getState().chains)==null?void 0:r.find(o=>o.chainId===n);if(i)return i}).filter(Boolean),clear:be}},fr=({onError:e,onLoading:t,onSuccess:n}={})=>{let r=useMutation(["USE_SUGGEST_CHAIN",e,t,n],Oe,{onError:(o,s)=>Promise.resolve(e==null?void 0:e(o,s.chainInfo)),onMutate:o=>t==null?void 0:t(o.chainInfo),onSuccess:o=>Promise.resolve(n==null?void 0:n(o))});return {error:r.error,isLoading:r.isLoading,isSuccess:r.isSuccess,suggest:r.mutate,suggestAsync:r.mutateAsync,status:r.status}},gr=({onError:e,onLoading:t,onSuccess:n}={})=>{let r=useMutation(["USE_SUGGEST_CHAIN_AND_CONNECT",e,t,n],ot,{onError:(s,a)=>Promise.resolve(e==null?void 0:e(s,a)),onMutate:s=>t==null?void 0:t(s),onSuccess:s=>Promise.resolve(n==null?void 0:n(s))}),{data:o}=fe();return {error:r.error,isLoading:r.isLoading,isSuccess:r.isSuccess,isSupported:!!o,status:r.status,suggestAndConnect:r.mutate,suggestAndConnectAsync:r.mutateAsync}};var Tr=({onError:e,onLoading:t,onSuccess:n}={})=>{let{data:i}=V(),r=i==null?void 0:i.bech32Address,o=useMutation(["USE_SEND_TOKENS",e,t,n,r],s=>rt(E({senderAddress:r},s)),{onError:(s,a)=>Promise.resolve(e==null?void 0:e(s,a)),onMutate:t,onSuccess:s=>Promise.resolve(n==null?void 0:n(s))});return {error:o.error,isLoading:o.isLoading,isSuccess:o.isSuccess,sendTokens:o.mutate,sendTokensAsync:o.mutateAsync,status:o.status}},Er=({onError:e,onLoading:t,onSuccess:n}={})=>{let{data:i}=V(),r=i==null?void 0:i.bech32Address,o=useMutation(["USE_SEND_IBC_TOKENS",e,t,n,r],s=>st(E({senderAddress:r},s)),{onError:(s,a)=>Promise.resolve(e==null?void 0:e(s,a)),onMutate:t,onSuccess:s=>Promise.resolve(n==null?void 0:n(s))});return {error:o.error,isLoading:o.isLoading,isSuccess:o.isSuccess,sendIbcTokens:o.mutate,sendIbcTokensAsync:o.mutateAsync,status:o.status}},br=({codeId:e,onError:t,onLoading:n,onSuccess:i})=>{let{data:r}=V(),o=r==null?void 0:r.bech32Address,a=useMutation(["USE_INSTANTIATE_CONTRACT",t,n,i,e,o],c=>{var m;if(!o)throw new Error("senderAddress is undefined");let u=B(E({},c),{fee:(m=c.fee)!=null?m:"auto",senderAddress:o,codeId:e});return at(u)},{onError:(c,u)=>Promise.resolve(t==null?void 0:t(c,u)),onMutate:n,onSuccess:c=>Promise.resolve(i==null?void 0:i(c))});return {error:a.error,isLoading:a.isLoading,isSuccess:a.isSuccess,instantiateContract:a.mutate,instantiateContractAsync:a.mutateAsync,status:a.status}},Or=({contractAddress:e,onError:t,onLoading:n,onSuccess:i})=>{let{data:r}=V(),o=r==null?void 0:r.bech32Address,a=useMutation(["USE_EXECUTE_CONTRACT",t,n,i,e,o],c=>{var m,S,w;if(!o)throw new Error("senderAddress is undefined");let u=B(E({},c),{fee:(m=c.fee)!=null?m:"auto",senderAddress:o,contractAddress:e,memo:(S=c.memo)!=null?S:"",funds:(w=c.funds)!=null?w:[]});return ct(u)},{onError:(c,u)=>Promise.resolve(t==null?void 0:t(c,u)),onMutate:n,onSuccess:c=>Promise.resolve(i==null?void 0:i(c))});return {error:a.error,isLoading:a.isLoading,isSuccess:a.isSuccess,executeContract:a.mutate,executeContractAsync:a.mutateAsync,status:a.status}},Mr=e=>{let{data:t}=ke();return useQuery(["USE_QUERY_SMART",e==null?void 0:e.address,e==null?void 0:e.queryMsg,t],({queryKey:[,i]})=>{if(!(e!=null&&e.address)||!e.queryMsg)throw new Error("address or queryMsg undefined");return lt(e.address,e.queryMsg,t)},{enabled:!!(e!=null&&e.address)&&!!(e!=null&&e.queryMsg)&&!!t})},xr=e=>{let{data:t}=ke(),n=["USE_QUERY_RAW",e==null?void 0:e.key,e==null?void 0:e.address,t];return useQuery(n,({queryKey:[,r]})=>{if(!(e!=null&&e.address)||!e.key)throw new Error("address or key undefined");return ut(e.address,e.key,t)},{enabled:!!(e!=null&&e.address)&&!!(e!=null&&e.key)&&!!t})};function qr(e){let t=U({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),n=d(o=>o.walletType),i=y(o=>o.activeChainIds),r=useMemo(()=>["USE_STARGATE_SIGNING_CLIENT",t,n,e,i],[i,e,t,n]);return useQuery({queryKey:r,queryFn:a=>l(this,[a],function*({queryKey:[,o,s]}){if(o.length<1)throw new Error("No chains found");return yield G(!!(e!=null&&e.multiChain),o,u=>l(this,null,function*(){var T,v;if(!(i!=null&&i.includes(u.chainId)))return;if(!D(s))throw new Error(`${s} is not available`);let S=yield (()=>l(this,null,function*(){switch(e==null?void 0:e.offlineSigner){case"offlineSigner":return k(s).getOfflineSigner(u.chainId);case"offlineSignerAuto":return k(s).getOfflineSignerAuto(u.chainId);case"offlineSignerOnlyAmino":return k(s).getOfflineSignerOnlyAmino(u.chainId);default:return k(s).getOfflineSignerAuto(u.chainId)}}))(),w=(T=d.getState().chainsConfig)==null?void 0:T[u.chainId],h={url:u.rpc,headers:E({},(w==null?void 0:w.rpcHeaders)||{})};return (e==null?void 0:e.multiChain)===!0&&e.opts,yield SigningStargateClient.connectWithSigner(h,S,e!=null&&e.multiChain?(v=e.opts)==null?void 0:v[u.chainId]:e==null?void 0:e.opts)}))}),enabled:!!t&&t.length>0&&!!n&&((e==null?void 0:e.enabled)!==void 0?!!e.enabled:!0),refetchOnWindowFocus:!1})}function Gr(e){let t=U({chainId:e==null?void 0:e.chainId,multiChain:e==null?void 0:e.multiChain}),n=d(o=>o.walletType),i=y(o=>o.activeChainIds),r=useMemo(()=>["USE_COSMWASM_SIGNING_CLIENT",t,n,e,i],[i,e,t,n]);return useQuery({queryKey:r,queryFn:a=>l(this,[a],function*({queryKey:[,o,s]}){if(o.length<1)throw new Error("No chains found");return yield G(!!(e!=null&&e.multiChain),o,u=>l(this,null,function*(){var v,P;if(!(i!=null&&i.includes(u.chainId)))return;if(!D(s))throw new Error(`${s} is not available`);let S=yield (()=>l(this,null,function*(){switch(e==null?void 0:e.offlineSigner){case"offlineSigner":return k(s).getOfflineSigner(u.chainId);case"offlineSignerAuto":return k(s).getOfflineSignerAuto(u.chainId);case"offlineSignerOnlyAmino":return k(s).getOfflineSignerOnlyAmino(u.chainId);default:return k(s).getOfflineSignerAuto(u.chainId)}}))(),w=(v=d.getState().chainsConfig)==null?void 0:v[u.chainId],h={url:u.rpc,headers:E({},(w==null?void 0:w.rpcHeaders)||{})},b=w!=null&&w.gas?GasPrice.fromString(`${w.gas.price}${w.gas.denom}`):void 0;return yield SigningCosmWasmClient.connectWithSigner(h,S,E({gasPrice:b},e!=null&&e.multiChain?(P=e.opts)==null?void 0:P[u.chainId]:(e==null?void 0:e.opts)||{}))}))}),enabled:!!t&&t.length>0&&!!n&&((e==null?void 0:e.enabled)!==void 0?!!e.enabled:!0),refetchOnWindowFocus:!1})}function Fr(e){let t=U({chainId:e.chainId,multiChain:e.multiChain}),n=d(s=>s.walletType),i=y(s=>s.activeChainIds),r=useMemo(()=>["USE_STARGATE_TM_SIGNING_CLIENT",t,n,e,i],[i,e,t,n]),{data:o}=pe({type:e.type,chainId:e.chainId,multiChain:e.multiChain});return useQuery({queryKey:r,queryFn:c=>l(this,[c],function*({queryKey:[,s,a]}){if(s.length<1)throw new Error("No chains found");return yield G(!!e.multiChain,s,m=>l(this,null,function*(){var T;if(!(i!=null&&i.includes(m.chainId)))return;if(!D(a))throw new Error(`${a} is not available`);if(!o)throw new Error("No tendermint client found");let w=yield (()=>l(this,null,function*(){switch(e.offlineSigner){case"offlineSigner":return k(a).getOfflineSigner(m.chainId);case"offlineSignerAuto":return k(a).getOfflineSignerAuto(m.chainId);case"offlineSignerOnlyAmino":return k(a).getOfflineSignerOnlyAmino(m.chainId);default:return k(a).getOfflineSignerAuto(m.chainId)}}))(),h=e.multiChain?o[m.chainId]:o;return yield SigningStargateClient.createWithSigner(h,w,e.multiChain?(T=e.opts)==null?void 0:T[m.chainId]:e.opts)}))}),enabled:!!t&&t.length>0&&!!n&&!!o&&(e.enabled!==void 0?!!e.enabled:!0),refetchOnWindowFocus:!1})}function zr(e){let t=U({chainId:e.chainId,multiChain:e.multiChain}),n=d(a=>a.walletType),i=y(a=>a.activeChainIds),r=useMemo(()=>["USE_COSMWASM_TM_SIGNING_CLIENT",t,n,e,i],[i,e,t,n]),{data:o}=pe({type:e.type,chainId:e.chainId,multiChain:!1,enabled:!e.multiChain}),{data:s}=pe({type:e.type,chainId:e.chainId,multiChain:!0,enabled:!!e.multiChain});return useQuery({queryKey:r,queryFn:u=>l(this,[u],function*({queryKey:[,a,c]}){if(a.length<1)throw new Error("No chains found");return yield G(!!e.multiChain,a,S=>l(this,null,function*(){var C,A;if(!(i!=null&&i.includes(S.chainId)))return;if(!D(c))throw new Error(`${c} is not available`);let h=yield (()=>l(this,null,function*(){switch(e.offlineSigner){case"offlineSigner":return k(c).getOfflineSigner(S.chainId);case"offlineSignerAuto":return k(c).getOfflineSignerAuto(S.chainId);case"offlineSignerOnlyAmino":return k(c).getOfflineSignerOnlyAmino(S.chainId);default:return k(c).getOfflineSignerAuto(S.chainId)}}))(),b=(C=d.getState().chainsConfig)==null?void 0:C[S.chainId],T=b!=null&&b.gas?GasPrice.fromString(`${b.gas.price}${b.gas.denom}`):void 0,v=e.multiChain?s==null?void 0:s[S.chainId]:o;if(!v)throw new Error("No tendermint client found");return yield SigningCosmWasmClient.createWithSigner(v,h,E({gasPrice:T},e.multiChain?(A=e.opts)==null?void 0:A[S.chainId]:e.opts||{}))}))}),enabled:!!t&&t.length>0&&!!n&&(!!o||!me(s))&&(e.enabled!==void 0?!!e.enabled:!0),refetchOnWindowFocus:!1})}var Et=({children:e})=>{let[t,n]=useState(!1);return useEffect(()=>{n(!0);},[]),jsx(Fragment,{children:t?e:null})};var on=()=>{let e=typeof window!="undefined"&&window.sessionStorage.getItem(Z)==="Active",{_reconnect:t,_onReconnectFailed:n,_reconnectConnector:i}=d(),{activeChainIds:r,wcSignClients:o}=y(),s=D(i||void 0);return useEffect(()=>{if(i){if(!s)return;e&&r?z({onError:n}):!e&&t&&z({onError:n});}},[s]),useEffect(()=>{var a,c,u,m,S,w,h,b,T,v,P,C;if(i){if(!s)return;i==="cosmostation"&&((c=(a=ae()).subscription)==null||c.call(a,()=>{z({onError:n});})),i==="keplr"&&((m=(u=ce()).subscription)==null||m.call(u,()=>{z({onError:n});})),i==="leap"&&((w=(S=le()).subscription)==null||w.call(S,()=>{z({onError:n});})),i==="vectis"&&((b=(h=de()).subscription)==null||b.call(h,()=>{z({onError:n});})),i==="walletconnect"&&o.has("walletconnect")&&((v=(T=$()).subscription)==null||v.call(T,()=>{z({onError:n});})),i==="station"&&((C=(P=ue()).subscription)==null||C.call(P,()=>{z({onError:n});}));}},[i,o,s]),null},Ot=()=>(on(),null);var an=new QueryClient({}),gs=i=>{var r=i,{children:e,grazOptions:t}=r,n=qe(r,["children","grazOptions"]);return it(t),jsx(QueryClientProvider,B(E({client:an},n),{children:jsxs(Et,{children:[e,jsx(Ot,{})]})}),"graz-provider")};

export { Ot as GrazEvents, gs as GrazProvider, Fe as WALLET_TYPES, Ge as WalletType, D as checkWallet, be as clearRecentChain, Q as clearSession, it as configureGraz, te as connect, di as defineChainInfo, ui as defineChains, Ee as disconnect, ct as executeContract, Uo as getAvailableWallets, ae as getCosmostation, ce as getKeplr, le as getLeap, He as getMetamaskSnapLeap, nt as getOfflineSigners, ut as getQueryRaw, lt as getQuerySmart, Zo as getRecentChainIds, ei as getRecentChains, de as getVectis, Xe as getWCCosmostation, Ze as getWCKeplr, et as getWCLeap, k as getWallet, $ as getWalletConnect, at as instantiateContract, tt as isWalletConnect, z as reconnect, st as sendIbcTokens, rt as sendTokens, Oe as suggestChain, ot as suggestChainAndConnect, V as useAccount, ur as useActiveChainCurrency, lr as useActiveChainIds, Xt as useActiveChains, Li as useActiveWalletType, Ji as useBalance, tr as useBalanceStaked, Jt as useBalances, fe as useCheckWallet, Xi as useConnect, ke as useCosmWasmClient, Gr as useCosmWasmSigningClient, zr as useCosmWasmTmSigningClient, Zi as useDisconnect, Or as useExecuteContract, on as useGrazEvents, br as useInstantiateContract, er as useOfflineSigners, dr as useQueryClientValidators, xr as useQueryRaw, Mr as useQuerySmart, mr as useRecentChainIds, pr as useRecentChains, Er as useSendIbcTokens, Tr as useSendTokens, Re as useStargateClient, qr as useStargateSigningClient, Fr as useStargateTmSigningClient, fr as useSuggestChain, gr as useSuggestChainAndConnect, pe as useTendermintClient };
